﻿unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.Buttons, math,
  mp_types, mp_real;

type
  TELLIPSE = record
    fRad_X        : double;     // X 方向半径
    fRad_Y        : double;     // Y 方向半径
    fAngle        : double;     // 楕円角度
    fCx           : double;     // 楕円中心位置 X
    fcy           : double;     // 楕円中心位置 Y
    startAngle    : double;     // 開始角
    endAngle      : double;     // 終了角
  end;

  mTarray3x3 = array[1..3] of array[1..3] of mp_float;

  TForm1 = class(TForm)
    Panel1: TPanel;
    Ellipse1Box: TGroupBox;
    radius_a1_Edit: TLabeledEdit;
    radius_b1_Edit: TLabeledEdit;
    Center_x1_Edit: TLabeledEdit;
    Center_y1_Edit: TLabeledEdit;
    angle_q1_Edit: TLabeledEdit;
    Ellipse2Box: TGroupBox;
    radius_a2_Edit: TLabeledEdit;
    radius_b2_Edit: TLabeledEdit;
    Center_x2_Edit: TLabeledEdit;
    Center_y2_Edit: TLabeledEdit;
    angle_q2_Edit: TLabeledEdit;
    Panel2: TPanel;
    SelectBtn: TBitBtn;
    Image1: TImage;
    End_angle_E2: TLabeledEdit;
    Start_angle_S2: TLabeledEdit;
    Start_angle_S1: TLabeledEdit;
    End_angle_E1: TLabeledEdit;
    Timer1: TTimer;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure SelectBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);

  private
    { Private 宣言 }
    procedure imageClear;
    function Dist(x1, y1, x2, y2 : double): double ;
    function Angle(dx, dy: double): double ;
    procedure LineSub(Tcv: TCanvas; px1, py1, px2, py2: double);
    procedure pitchControl(NLine, LW: integer);
    procedure LineSubPitch(Tcv : TCanvas; Ln: integer; var i: integer; var d1: double; px1, py1, px2, py2: double);
    function angleSe(a, b, rad: double): double;
    procedure EllipseEx(Tcv: TCanvas; h, lf, lw: integer; lc: Tcolor; a, b, x, y, rq, sq, eq: double);
    procedure quadratic_transform(a, b, x, y, qdeg: mp_float; var A0, B0, C0, D0, E0, F0: mp_float);
    procedure determinant(ma, mb, mc, md, me, mf: mp_float; var marrayf: mTarray3x3);
    procedure difference0(ma1, ma2, ma3, mb1, mb2, mb3: mp_float; var mah03, mah02, mah01, mah00: mp_float; addf: boolean);
    function cubicequation(ma, mb, mc, md: mp_float; var mcub2, mcub1, mcub0: mp_float): byte;
    procedure inputdata_drawing;
    procedure cross_calc;
    procedure difference1(marr1, marr2: mTarray3x3; var mah03, mah02, mah01, mah00: mp_float);
    procedure difference2(marr1, marr2: mTarray3x3; var marr3: mTarray3x3);
    procedure difference3(marr3: mTarray3x3; var ma, mh, mb, mg, mf, mc, mdet: mp_float);
    function factorization(ma, mh, mb, mg, mf, mc: mp_float; var malf1, mbta1, mgam1, malf2, mbta2, mgam2: mp_float): boolean;
    function factorization2(ma, mh, mb, mg, mf, mc: mp_float; var mar, malfa: mp_float): boolean;
    function quadratic(mA, mB, mC, mD, mE, mF, ma1, mb1, mg1: mp_float; var mx1, mx2: mp_float): byte;
    function quadratic4(mA1, mB1, mC1, mD1, mE1, mF1, mg, mf, mc: mp_float; var mx1, mx2: mp_float): boolean;
    procedure StraightLineDraw(Tcv: TCanvas; h, lf, lw: integer; lc: Tcolor; xs, ys, xe, ye: double; sf: boolean);
    function intersection_judge(Ellipse1, Ellipse2: TEllipse; X, Y: double): boolean;
    function angle_amendment(angle : double): double;
    procedure angle180_amendment(var mangle : mp_float);
    procedure calcbegin;

  public
    { Public 宣言 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  PitchN = 5;                                 // 線ピッチ設定数
  LineN  = 3;                                 // 線種数
  LIMIT8 = 0.00000001;

type
  TLinePitch = Record                         // 線種用レコード
    Pitch   : array[0..PitchN] of double;     // ピッチ 線長さ 空白の繰り返し
    segment : integer;                        // ピッチ数
  End;



var
  LPitch    : array of TLinePitch;            // 線種用 (線ピッチ)
  VPitch    : array[0..PitchN] of double;     // 線幅による線ピッチ設定用

  magnification : double;
  ar1, ar2      : double;
  br1, br2      : double;
  xo1, xo2      : double;
  yo1, yo2      : double;

  Ellipse1      : TELLIPSE;                   // 楕円１
  Ellipse2      : TELLIPSE;                   // 楕円２

  shift_x       : double;
  shift_y       : double;

  scale         : double;
  xshift        : double;
  yshift        : double;

  d01           : double;
  d0p           : integer;

  ZeroAngleF    : boolean;                    // 楕円選択フラグ

  TimerF        : Boolean;

  mar1, mar2      : mp_float;                 // 半径 a
  mbr1, mbr2      : mp_float;                 // 半径 b
  mxo1, mxo2      : mp_float;                 // 中心座標 x
  myo1, myo2      : mp_float;                 // 中心座標 y
  mq1,  mq2       : mp_float;                 // 楕円角   q
  mst1, mst2      : mp_float;                 // 開始角   st
  med1, med2      : mp_float;                 // 終了角   ed
  mscale          : mp_float;


const
  draw_margin = 30;                           // 左右上下作図マージン

procedure TForm1.imageClear;
begin
  image1.Canvas.Brush.Style := bsSolid;
  image1.Canvas.Brush.Color := clWhite;
  image1.Canvas.FillRect(Rect(0, 0, image1.Width, image1.Height));
end;

//-----------------------------------------------
// 線幅によるピッチの補正
// 線幅を広くするとスペースが狭くなるので広げます
// NLine 線種
// LW    線幅
//-----------------------------------------------
procedure TForm1.pitchControl(NLine, LW: integer);
var
  i : integer;
begin
  // 線幅によるピッチの補正
  for i := 0 to pitchN do begin
    if i mod 2 <> 0 then                              // 奇数配列noセグメントがスペース
      Vpitch[i] := LPitch[NLine].Pitch[i] + LW        // スペースに線幅加算
    else
      Vpitch[i] := LPitch[NLine].Pitch[i];
  end;
end;

//----------------------------
// 作図用　二点間線引き
//----------------------------
procedure TForm1.LineSub(Tcv: TCanvas; px1, py1, px2, py2: double);
var
  x1, y1, x2, y2 : integer ;
begin
  x1 := Round(px1);
  y1 := Round(py1);
  x2 := Round(px2);
  y2 := Round(py2);
  Tcv.MoveTo(x1, y1);
  Tcv.LineTo(x2, y2);
end;

//----------------------
// 距離（長さ）を計算
//　　x1, y1 : 始点
//　　x2, y2 : 終点
//　　out : 距離(長さ)
//----------------------
function TForm1.Dist(x1, y1, x2, y2 : double): double ;
begin
	Result := Sqrt((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1)) ;
end;

//--------------------------------
// 角度を計算[rad]
//　　dx : X方向差分
//　　dy : Y方向差分
//　　out: 角度 (0～2 * Pi)
//--------------------------------
function TForm1.Angle(dx, dy: double): double ;
var
  r : double ;
begin
	Result := 0.0;
	if (Abs(dx) < LIMIT8) and (Abs(dy) < LIMIT8) then exit;
	r := ArcTan2(dy, dx);
	if r < 0.0 then r := r + 2.0 * Pi;
  Result := r;
end;

//--------------------------------------
// 線分の表示・サブ２：線種指定
//    Ln : 線種番号(1-)
//    i  : 開始セグメント番号(終了時更新)
//    d1 : 開始ピッチ長さ　　(終了時更新)
//    px1, py1 : 線分始点[mm]
//    px2, py2 : 線分終点[mm]
//--------------------------------------
procedure TForm1.LineSubPitch(Tcv: TCanvas; Ln: integer; var i: integer; var d1: double; px1, py1, px2, py2: double);
var
  x1, y1, x2, y2  : double;
  a, sa, ca, d, p : double;
  PenStyle        : TPenstyle;
begin
  PenStyle := Tcv.Pen.Style;                    // 線種バックアップ
  Tcv.Pen.Style := psSolid;
  if (Ln < 0) or (Ln >= LineN) then begin       // 無い線種は実線
    LineSub(Tcv, px1, py1, px2, py2);
    Tcv.Pen.Style := PenStyle;                  // 線種戻し
    exit;
  end;
  a := Angle(px2 - px1, py2 - py1);             // 角度計算
  d := Dist(px1, py1, px2, py2);                // 距離計算
  ca:= Cos(a);                                  // コサイン
  sa:= Sin(a);                                  // サイン
  x1:= px1;                                     // 始点x
  y1:= py1;                                     // 始点y
  repeat
    p := Vpitch[i] - d1;                        // ピッチと開始ピッチ長さ差分 残り分
    if (p > d) then p := d;                     // 距離より残り分が大きい場合 距離
    x2 := x1 + p * ca;                          // 新しい位置計算
    y2 := y1 + p * sa;
    if (i mod 2) = 0 then                       // セグメント偶数毎に線引き 空白部線引きしない
         LineSub(Tcv, x1, y1, x2, y2);
    x1 := x2;                                   // 終点を始点にセット
    y1 := y2;
    d := d - p ;                                // 残り長さ計算
    if d > LIMIT8 then begin                    // 残り長さがあったら
      d1 := 0.0;                                // 開始ピッチ長さクリア
      Inc(i);                                   // セグメントカウンターインクリメント
      if i >= LPitch[Ln].segment then i := 0;   // セグメント数を超えたらゼロに戻し
    end;
  until d <= LIMIT8;
  d1 := d1 + p;                                 // 開始ピッチ長さ
  Tcv.Pen.Style := PenStyle;                    // 線種戻し
end;

//------------------------------------------
// 楕円の開始角を 基礎円の開始角に変換
//------------------------------------------
function TForm1.angleSe(a, b, rad: double): double;
const
  KMIN = 0.00000001;
var
  l : double;
begin
  // 90°, 270°, 0°, 180° 360°近傍は計算しない
  if (abs(rad - pi / 2) < KMIN) or (abs(rad - pi - pi / 2) < KMIN)
      or (abs(rad) < KMIN) or (abs(rad - pi) < KMIN) or
      (abs(rad - pi * 2) < KMIN)
  then begin
    result := rad;
    exit;
  end;
  // 底辺の長さ計算 ( b / a の値がいつも正の値なので元の角度によって角度を補正)
  // 分母がゼロに近くなる時もあるので、判別が不要なarctan2を使用します
  l := b / a / tan(rad);
  // 180°以下だったら
  if rad < pi then
    result := arctan2(1, l)
  else
    // 360°以下だったら
    if rad < pi * 2 then
      result := arctan2(1, l) + pi
    // 360°を超えていたら
    else
      result := arctan2(1, l) + pi * 2;
end;

//---------------------------------------
// 楕円の描画
// Windows為ののy方向変換は,このルーチンで行います。
// tcv   描画キャンバスの指定
// h     キャンバスの高さ
// lf    線の種類
// lw    線の幅
// lc    線の色
// a     半径a
// b     半径b
// x     中心位置 x
// y     中心位置 y
// rq    楕円の角度
// sq    描画開始角
// eq    描画終了
//---------------------------------------
procedure TForm1.EllipseEx(Tcv : TCanvas; h, lf, lw: integer; lc: Tcolor; a, b, x, y, rq, sq, eq: double);
var
  sqrad, eqrad    : double;
  qrad            : double;
  Ssqrad, Seqrad  : double;
  sp              : integer;
  dq              : double;
  d1              : double;
  dp              : integer;
  xf, yf          : double;
  rdist, nrad     : double;
  px1, py1        : double;
  px2, py2        : double;
  i               : integer;
begin
  Tcv.Pen.Width := lw;
  Tcv.Pen.Color := lc;
  // y方向変換
  y := h - y;
  // 線幅によるピッチの補正
  pitchControl(lf, lw);

  // 終了角と開始角が一致したら全周
  if abs(sq - eq) < LIMIT8 then begin
    sq := 0;
    eq := 360;
  end;

  sp := round(sqrt(a + b) * 4);               // 分割数

  // 楕円の計算と描画
  sqrad := sq / 180 * pi;
  eqrad := eq / 180 * pi;

  qrad  := pi / 180 * rq;                     // 回転角 ラジアン

  Ssqrad := angleSe(a, b, sqrad);             // 基本円角度に変換
  Seqrad := angleSe(a, b, eqrad);             // 基本円角度に変換
  // 分割微小角計算  分割数角度で補正
  if Seqrad >= Ssqrad then begin
    sp := round(sp * (Seqrad - Ssqrad) / pi);
    if sp = 0 then sp := 1;
    dq := (Seqrad - Ssqrad) / sp              // 分割微小角 ラジアン
  end
  else begin
    sp := round(sp * (Pi * 2 - Ssqrad + Seqrad) / pi);
    if sp = 0 then sp := 1;
    dq := (Pi * 2 - Ssqrad + Seqrad) / sp;    // 分割微小角 ラジアン
  end;
  // 開始点の計算
  d1 := 0;                                    // 長さ
  dp := 0;                                    // セグメント位置
  xf := cos(Ssqrad) *  a;                     // 基本楕円座標X スタート座標
  yf := sin(Ssqrad) *  b;                     // 基本楕円座標y スタート座標
  nrad := arctan2(yf, xf) + qrad;             // 新しい角度 回転角加算
  rdist := sqrt(xf * xf + yf * yf);           // 中心と楕円座標の距離
  px1 := cos(nrad) * rdist + x;               // 開始座標X
  py1 := sin(nrad) * -rdist + y;              // 開始座標Y -rdistはY座標反転の為
                                              // WindowはY座標方向が逆のため
  // 分割数分計算繰り返し描画
  for i := 1 to sp do begin
    xf := cos(Ssqrad + dq * i) * a;
    yf := sin(Ssqrad + dq * i) * b;
    nrad := arctan2(yf , xf) + qrad;
    rdist := sqrt(xf * xf + yf * yf);
    px2 := round(cos(nrad) * rdist + x);      // 終点座標X
    py2 := round(sin(nrad) * -rdist + y);     // 終点座標Y
    // ピッチ線描画
    LineSubPitch(                             // ピッチ線描画
                tcv,                          // TCanvas
                 lf,                          // 線種
                 dp,                          // セグメント位置
                 d1,                          // 長さ
                px1,                          // 始点X
                py1,                          // 始点Y
                px2,                          // 終点X
                py2                           // 終点Y
                   );
    px1 := px2;                               // 終点Xを始点Xに
    py1 := py2;                               // 終点Yを始点Yに
  end;
end;

//-------------------------------------------------------------
// 直線の描画
// 直線の開始はsfをTrueにします。
// つながった直線、折れ線を描画する場合は、sfをFalseに
//-------------------------------------------------------------
procedure TForm1.StraightLineDraw(Tcv: TCanvas; h, lf, lw: integer; lc: Tcolor; xs, ys, xe, ye: double; sf: boolean);
begin
  Tcv.Pen.Width := lw;
  Tcv.Pen.Color := lc;
  // 線幅によるピッチの補正
  pitchControl(lf, lw);
  // y方向変換
  ys := h - ys;
  ye := h - ye;
  if sf then begin
    d01 := 0;
    d0p := 0;
  end;
  LineSubPitch(                               // ピッチ線描画
                tcv,                          // TCanvas
                 lf,                          // 線種
                d0p,                          // セグメント位置
                d01,                          // 長さ
                 xs,                          // 始点X
                 ys,                          // 始点Y
                 xe,                          // 終点X
                 ye                           // 終点Y
                   );
end;

//-------------------------------------------------
// 楕円の方程式　二次方程式への変換
// AX^2 + BXY + CY^2 + DX + EY + F の A,B,C,D,E,F　
//-------------------------------------------------
procedure TForm1.quadratic_transform(a, b, x, y, qdeg: mp_float; var A0, B0, C0, D0, E0, F0: mp_float);
var
  Q            : mp_float;
  sin_Q, cos_Q : mp_float;
  mpi          : mp_float;
  tmp0,  tmp1, tmp2, tmp3, tmp4: mp_float;
  ah2, bh2     : mp_float;
  inv_ah2, inv_bh2 : mp_float;
  sin_Qh2, cos_Qh2, cossin_Q : mp_float;
  xh2, yh2, xy : mp_float;
//  F0D, E0D, D0D, C0D, B0D, A0D: double;
begin
  mpf_init3(Q, sin_Q, cos_Q);
  mpf_init(mpi);
  mpf_init5(tmp0, tmp1, tmp2, tmp3, tmp4);
  mpf_init2(ah2, bh2);
  mpf_init2(inv_ah2, inv_bh2);
  mpf_init3(sin_Qh2, cos_Qh2, cossin_Q);
  mpf_init3(xh2, yh2, xy);

//  Q := qdeg / 180 * pi;     // ラジアン単位に変換
  mpf_set_pi(mpi);
  mpf_div_int(qdeg, 180, tmp0);  // ラジアン単位に変換
  mpf_mul(tmp0, mpi, Q);         // Q rad

  mpf_sin(Q, sin_Q);
  mpf_cos(Q, cos_Q);

  mpf_sqr(a, ah2);
  mpf_sqr(b, bh2);
  mpf_sqr(sin_Q, sin_Qh2);
  mpf_sqr(cos_Q, cos_Qh2);
  mpf_mul(sin_Q, cos_Q, cossin_Q);

//  A0 := cos_Q * cos_Q / a / a + sin_Q * sin_Q / b / b;
  mpf_div(cos_Qh2, ah2, tmp0);
  mpf_div(sin_Qh2, bh2, tmp1);
  mpf_add(tmp0, tmp1, A0);

//  B0 := 2 * (1 / a / a - 1 / b / b) * sin_Q * cos_Q;
  mpf_inv(ah2, inv_ah2);
  mpf_inv(bh2, inv_bh2);
  mpf_sub(inv_ah2, inv_bh2, tmp0);
  mpf_mul_int(tmp0, 2, tmp1);
  mpf_mul(tmp1, cossin_Q, B0);

//  C0 := sin_Q * sin_Q / a / a + cos_Q * cos_Q / b / b;
  mpf_mul(sin_Qh2, inv_ah2, tmp0);
  mpf_mul(cos_Qh2, inv_bh2, tmp1);
  mpf_add(tmp0, tmp1, C0);

//  D0 := -2 * ((x * cos_Q * cos_Q + y * sin_Q * cos_Q) / a / a + (x * sin_Q * sin_Q - y * sin_Q * cos_Q) / b / b);
  mpf_mul(x, cos_Qh2, tmp0);
  mpf_mul(y, cossin_Q, tmp1);
  mpf_add(tmp0, tmp1, tmp2);
  mpf_mul(tmp2, inv_ah2, tmp0);

  mpf_mul(x, sin_Qh2, tmp1);
  mpf_mul(y, cossin_Q, tmp2);
  mpf_sub(tmp1, tmp2, tmp3);
  mpf_mul(tmp3, inv_bh2, tmp1);

  mpf_add(tmp0, tmp1, tmp2);
  mpf_mul_int(tmp2, -2, D0);

//  E0 := -2 * ((x * sin_Q * cos_Q + y * sin_Q * sin_Q) / a / a + (y * cos_Q * cos_Q - x * sin_Q * cos_Q) / b / b);
  mpf_mul(x, cossin_Q, tmp0);
  mpf_mul(y, sin_Qh2, tmp1);
  mpf_add(tmp0, tmp1, tmp2);
  mpf_mul(tmp2, inv_ah2, tmp0);

  mpf_mul(y, cos_Qh2, tmp1);
  mpf_mul(x, cossin_Q, tmp2);
  mpf_sub(tmp1, tmp2, tmp3);
  mpf_mul(tmp3, inv_bh2, tmp1);

  mpf_add(tmp0, tmp1, tmp2);
  mpf_mul_int(tmp2, -2, E0);

//  F0 :=  (x * x * cos_Q * cos_Q + 2 * x * y * sin_Q * cos_Q + y * y * sin_Q * sin_Q) / a / a
//       + (x * x * sin_Q * sin_Q - 2 * x * y * sin_Q * cos_Q + y * y * cos_Q * cos_Q) / b / b
//       - 1;
  mpf_sqr(x, xh2);
  mpf_sqr(y, yh2);
  mpf_mul(x, y, xy);

  mpf_mul(xh2, cos_Qh2, tmp0);  // x^2 * cosQ^2
  mpf_mul(xy, cossin_Q, tmp1);  // xy * cosQ * sinQ
  mpf_mul_int(tmp1, 2, tmp2);   // 2 * xy * cosQ * sinQ
  mpf_mul(yh2, sin_Qh2, tmp3);  // y^2 * sinQ^2
  mpf_add(tmp0, tmp2, tmp1);    // x^2 * cosQ^2 + 2 * xy * cosQ * sinQ
  mpf_add(tmp1, tmp3, tmp0);    // x^2 * cosQ^2 + 2 * xy * cosQ * sinQ + y^2 * sinQ^2
  mpf_mul(tmp0, inv_ah2, tmp1); // / a^2   (1)

  mpf_mul(xh2, sin_Qh2, tmp0);  // x^2 * sinQ^2
  mpf_mul(xy, cossin_Q, tmp2);  // xy * cosQ * sinQ
  mpf_mul_int(tmp2, -2, tmp3);  // -2 * xy * cosQ * sinQ
  mpf_mul(yh2, cos_Qh2, tmp2);  // y^2 * cosQ^2
  mpf_add(tmp0, tmp3, tmp4);    // x^2 * sinQ^2 - 2 * xy * cosQ * sinQ
  mpf_add(tmp4, tmp2, tmp3);    // x^2 * sinQ^2 - 2 * xy * cosQ * sinQ + y^2 * cosQ^2
  mpf_mul(tmp3, inv_bh2, tmp2); // / b^2   (2)

  mpf_add(tmp1, tmp2, tmp3);    // (1) + (2)
  mpf_sub_int(tmp3, 1, F0);     // (1) + (2) - 1
{
  // 計算確認用
  A0D := mpf_Todouble(A0);
  B0D := mpf_Todouble(B0);
  C0D := mpf_Todouble(C0);
  D0D := mpf_Todouble(D0);
  E0D := mpf_Todouble(E0);
  F0D := mpf_Todouble(F0);
  image1.Canvas.TextOut(20,300, floatTostr(A0D));
  image1.Canvas.TextOut(20,320, floatTostr(B0D));
  image1.Canvas.TextOut(20,340, floatTostr(C0D));
  image1.Canvas.TextOut(20,360, floatTostr(D0D));
  image1.Canvas.TextOut(20,380, floatTostr(E0D));
  image1.Canvas.TextOut(20,400, floatTostr(F0D));
}

// メモリーの解放
  mpf_clear3(Q, sin_Q, cos_Q);
  mpf_clear(mpi);
  mpf_clear5(tmp0, tmp1, tmp2, tmp3, tmp4);
  mpf_clear2(ah2, bh2);
  mpf_clear2(inv_ah2, inv_bh2);
  mpf_clear3(sin_Qh2, cos_Qh2, cossin_Q);
  mpf_clear3(xh2, yh2, xy);
end;

//----------------------
// ３×３ 行列式への変換
//----------------------
procedure TForm1.determinant(ma, mb, mc, md, me, mf: mp_float; var marrayf: mTarray3x3);
var
  mb0, md0, me0: mp_float;
begin
  mpf_init3(mb0, md0, me0);

//b := b / 2, d := d / 2, e := e / 2
  mpf_div_int(mb, 2, mb0);
  mpf_div_int(md, 2, md0);
  mpf_div_int(me, 2, me0);

//  arrayf[1, 1] := a;
  mpf_copy(ma, marrayf[1, 1]);
//  arrayf[1, 2] := b / 2;
  mpf_copy(mb0, marrayf[1, 2]);
//  arrayf[1, 3] := d / 2;
  mpf_copy(md0, marrayf[1, 3]);
//  arrayf[2, 1] := b / 2;
  mpf_copy(mb0, marrayf[2, 1]);
//  arrayf[2, 2] := c;
  mpf_copy(mc, marrayf[2, 2]);
//  arrayf[2, 3] := e / 2;
  mpf_copy(me0, marrayf[2, 3]);
//  arrayf[3, 1] := d / 2;
  mpf_copy(md0, marrayf[3, 1]);
//  arrayf[3, 2] := e / 2;
  mpf_copy(me0, marrayf[3, 2]);
//  arrayf[3, 3] := f;
  mpf_copy(mf, marrayf[3, 3]);

  mpf_clear3(mb0, md0, me0);
end;

//------------------------
// 三次方程式への変換サブ
//------------------------
procedure TForm1.difference0(ma1, ma2, ma3, mb1, mb2, mb3: mp_float; var mah03, mah02, mah01, mah00: mp_float; addf: boolean);
var
  mTmp0, mtmp1, mtmp2 :mp_float;
  mah10, mah11, mah12, mah13 :mp_float;
begin
  mpf_init3(mTmp0, mtmp1, mtmp2);
  mpf_init4(mah10, mah11, mah12, mah13);
// mah13 := - b1 * b2 * b3;                                     // α^3
  mpf_chs(mb1, mTmp0);
  mpf_mul(mTmp0, mb2, mtmp1);
  mpf_mul(mTmp1, mb3, mah13);
// mah12 := a3 * b1 * b2 + a2 * b1 * b3 + a1 * b2 * b3;         // α^2
  mpf_mul(ma3, mb1, mtmp0);
  mpf_mul(mtmp0, mb2, mtmp0);
  mpf_mul(ma2, mb1, mtmp1);
  mpf_mul(mtmp1, mb3, mtmp1);
  mpf_mul(ma1, mb2, mtmp2);
  mpf_mul(mtmp2, mb3, mtmp2);
  mpf_add(mtmp0, mtmp1, mah12);
  mpf_add(mah12, mtmp2, mah12);
// mah11 := -(a2 * a3 * b1 + a1 * a3 * b2 + a1 * a2 * b3);      // α^1
  mpf_mul(ma2, ma3, mtmp0);
  mpf_mul(mtmp0, mb1, mtmp0);
  mpf_mul(ma1, ma3, mtmp1);
  mpf_mul(mtmp1, mb2, mtmp1);
  mpf_mul(ma1, ma2, mtmp2);
  mpf_mul(mtmp2, mb3, mtmp2);
  mpf_add(mtmp0, mtmp1, mah11);
  mpf_add(mah11, mtmp2, mtmp0);
  mpf_chs(mtmp0, mah11);
// mah10 :=   a1 * a2 * a3;                                     // c
  mpf_mul(ma1, ma2, mtmp0);
  mpf_mul(mtmp0, ma3, mah10);

  if addf then begin
    mpf_add(mah03, mah13, mah03);     // α^3
    mpf_add(mah02, mah12, mah02);     // α^2
    mpf_add(mah01, mah11, mah01);     // α^1
    mpf_add(mah00, mah10, mah00);     // c
  end
  else begin
    mpf_sub(mah03, mah13, mah03);     // α^3
    mpf_sub(mah02, mah12, mah02);     // α^2
    mpf_sub(mah01, mah11, mah01);     // α^1
    mpf_sub(mah00, mah10, mah00);     // c
  end;

  mpf_clear3(mTmp0, mtmp1, mtmp2);
  mpf_clear4(mah10, mah11, mah12, mah13);
end;

//---------------------------------------
// 二元二次行列連立式の三次方程式への変換
//---------------------------------------
procedure TForm1.difference1(marr1, marr2: mTarray3x3; var mah03, mah02, mah01, mah00: mp_float);
var
  mtp : mp_float;
begin
  mpf_init(mtp);

  mpf_set0(mah03);
  mpf_set0(mah02);
  mpf_set0(mah01);
  mpf_set0(mah00);

  difference0(marr1[1, 1], marr1[2, 2], marr1[3, 3],
              marr2[1, 1], marr2[2, 2], marr2[3, 3], mah03, mah02, mah01, mah00, true);
  difference0(marr1[1, 2], marr1[2, 3], marr1[3, 1],
              marr2[1, 2], marr2[2, 3], marr2[3, 1], mah03, mah02, mah01, mah00, true);
  difference0(marr1[1, 3], marr1[2, 1], marr1[3, 2],
              marr2[1, 3], marr2[2, 1], marr2[3, 2], mah03, mah02, mah01, mah00, true);
  difference0(marr1[1, 3], marr1[2, 2], marr1[3, 1],
              marr2[1, 3], marr2[2, 2], marr2[3, 1], mah03, mah02, mah01, mah00, false);
  difference0(marr1[1, 2], marr1[2, 1], marr1[3, 3],
              marr2[1, 2], marr2[2, 1], marr2[3, 3], mah03, mah02, mah01, mah00, false);
  difference0(marr1[1, 1], marr1[2, 3], marr1[3, 2],
              marr2[1, 1], marr2[2, 3], marr2[3, 2], mah03, mah02, mah01, mah00, false);

  mpf_clear(mtp);
end;

//---------------------
// ３×３行列式の差計算
//---------------------
procedure TForm1.difference2(marr1, marr2: mTarray3x3; var marr3: mTarray3x3);
var
  i, k: integer;
  mtmp, mabs: mp_float;
begin
  mpf_init2(mtmp, mabs);
  mpf_set_dbl(mtmp, 1E-32);
  for i := 1 to 3 do
    for k := 1 to 3 do begin
//      arr3[i, k] := arr1[i, k] - arr2[i, k];              // 差分計算
       mpf_sub(marr1[i, k], marr2[i, k], marr3[i, k]);
//      if abs(arr3[i, k]) < 1E-16 then arr3[i, k] := 0;    // 1E-14より小さかったらゼロ
    end;
// デバッグの為上から分離 因数分解と二次一次の計算境目設定確認の為 y 又は x 移動 0.001 近辺
// 1E-16 程度で、これより小さくすると、倍精度で因数分解とそうでない場合の境目で大きな誤差が
// 発生するようです。 double で 1E-16 程度
// もっと小さくして精度を上げるためには、多倍長演算が必要なようです。
  for i := 1 to 3 do
    for k := 1 to 3 do begin
//      if abs(arr3[i, k]) < 1E-16 then arr3[i, k] := 0;    // 1E-16より小さかったらゼロ
      mpf_abs(marr3[i, k], mabs);
      if mpf_is_lt(mabs, mtmp) then
                  mpf_set0(marr3[i, k]);
    end;
  mpf_clear2(mtmp, mabs);
end;

//-----------------------------
// ３×３行列式ｄｅｔ の計算
// 因数分解用方程式値の取り出し
//-----------------------------
procedure TForm1.difference3(marr3: mTarray3x3; var ma, mh, mb, mg, mf, mc, mdet: mp_float);   // detの計算
var
  ma1, ma2, ma3  : mp_float;
  mb1, mb2, mb3  : mp_float;
  mtmp0, mtmp1, mtmp2: mp_float;
begin
  mpf_init3(ma1, ma2, ma3);
  mpf_init3(mb1, mb2, mb3);
  mpf_init3(mtmp0, mtmp1, mtmp2);

//  a1 := arr3[1, 1] * arr3[2, 2] * arr3[3, 3];
  mpf_mul(marr3[1, 1], marr3[2, 2], mtmp0);
  mpf_mul(mtmp0, marr3[3, 3], ma1);
//  a2 := arr3[1, 2] * arr3[2, 3] * arr3[3, 1];
  mpf_mul(marr3[1, 2], marr3[2, 3], mtmp0);
  mpf_mul(mtmp0, marr3[3, 1], ma2);
//  a3 := arr3[1, 3] * arr3[2, 1] * arr3[3, 2];
  mpf_mul(marr3[1, 3], marr3[2, 1], mtmp0);
  mpf_mul(mtmp0, marr3[3, 2], ma3);
//  b1 := arr3[1, 3] * arr3[2, 2] * arr3[3, 1];
  mpf_mul(marr3[1, 3], marr3[2, 2], mtmp0);
  mpf_mul(mtmp0, marr3[3, 1], mb1);
//  b2 := arr3[2, 3] * arr3[3, 2] * arr3[1, 1];
  mpf_mul(marr3[2, 3], marr3[3, 2], mtmp0);
  mpf_mul(mtmp0, marr3[1, 1], mb2);
//  b3 := arr3[3, 3] * arr3[1, 2] * arr3[2, 1];
  mpf_mul(marr3[3, 3], marr3[1, 2], mtmp0);
  mpf_mul(mtmp0, marr3[2, 1], mb3);
//  det := a1 + a2 + a3 - b1 - b2 - b3;
  mpf_add(ma1, ma2, mtmp0);
  mpf_add(mtmp0, ma3, mtmp1);
  mpf_add(mb1, mb2, mtmp0);
  mpf_add(mtmp0, mb3, mtmp2);
  mpf_sub(mtmp1, mtmp2, mdet);

//  a := arr3[1, 1];                     // ax^2         二元二次方程式変換
  mpf_copy(marr3[1, 1], ma);
//  h := arr3[1, 2];                     // 2hxy
  mpf_copy(marr3[1, 2], mh);
//  b := arr3[2, 2];                     // by^2
  mpf_copy(marr3[2, 2], mb);
//  g := arr3[1, 3];                     // 2gx
  mpf_copy(marr3[1, 3], mg);
//  f := arr3[2, 3];                     // 2fy
  mpf_copy(marr3[2, 3], mf);
//  c := arr3[3, 3];                     // c
  mpf_copy(marr3[3, 3], mc);

  mpf_clear3(ma1, ma2, ma3);
  mpf_clear3(mb1, mb2, mb3);
  mpf_clear3(mtmp0, mtmp1, mtmp2);
end;

//--------------------------------------------------------------------
// 三次方程式の解法  カルダノの方法
// 実数解の値の時 byte  ビット0 ビット 1  ビット2 をそれぞれ１にします
//--------------------------------------------------------------------
function TForm1.cubicequation(ma, mb, mc, md: mp_float; var mcub2, mcub1, mcub0: mp_float): byte;
label
  POUT;
const
  MINIDE = 1E-24;                        // 1E-24
  MEM70  = 1E-70;                        // 追加
var
  mA2, mA1, mA0                           : mp_float;
  me1, me0, me1s3, me0s2, me02s4, me13s27 : mp_float;
  me02s4pe13s27                           : mp_float;
  xim1, xim2, xim3                        : string;

  mru, mrv, mruh1s3, mrvh1s3              : mp_float;
  mQu, mQv, mQus3, mQvs3                  : mp_float;
  mu1, mu2, mu3, mv1, mv2, mv3            : mp_float;
  mu1pv1, mu2pv3, mu3pv2                  : mp_float;

  mu1S, mu2S, mu3S, mv1S, mv2S, mv3S      : mp_float;
  mu1pv1S, mu2pv3S, mu3pv2S               : mp_float;
  mtmp0, mtmp1, mpi                       : mp_float;
  mtmp2, mtmp3                            : mp_float;
  mMINIDE                                 : mp_float;
  u1pv1S, u2pv3S, u3pv2S                  : double;
  cub2, cub1, cub0                        : double;
begin
  mpf_init3(mA2, mA1, mA0);
  mpf_init4(me1, me0, me1s3, me0s2);
  mpf_init3(me02s4, me13s27, me02s4pe13s27);
  mpf_init4(mru, mrv, mruh1s3, mrvh1s3);
  mpf_init4(mQu, mQv, mQus3, mQvs3);
  mpf_init4(mu1, mu2, mu3, mv1);
  mpf_init2(mv2, mv3);
  mpf_init3(mu1pv1, mu2pv3, mu3pv2);
  mpf_init4(mu1S, mu2S, mu3S, mv1S);
  mpf_init2(mv2S, mv3S);
  mpf_init3(mu1pv1S, mu2pv3S, mu3pv2S);
  mpf_init3(mtmp0, mtmp1, mpi);
  mpf_init(mMINIDE);
  mpf_init2(mtmp2, mtmp3);

  result := 0;
  mpf_set_dbl(mMINIDE, MINIDE);
//  if a = 0 then exit;
  if s_mpf_is0(ma) then goto POUT;
//  A2 := b / a;
  mpf_div(mb, ma, mA2);
//  A1 := c / a;
  mpf_div(mc, ma, mA1);
//  A0 := d / a;
  mpf_div(md, ma, mA0);
//  e1 := -A2 * A2 / 3 + A1;
  mpf_sqr(mA2, mtmp0);
  mpf_div_int(mtmp0, 3, mtmp1);
  mpf_chs(mtmp1, mtmp2);
  mpf_add(mtmp2, mA1, me1);
//  e0 := 2 / 27 * A2 * A2 * A2 - A2 * A1 / 3 + A0;
  mpf_set_int(mtmp0, 2);
  mpf_set_int(mtmp1, 27);
  mpf_div(mtmp0, mtmp1, mpi);   //  2 / 27
  mpf_expt_int(mA2, 3, mtmp0);  // A2^3
  mpf_mul(mtmp0, mpi, mtmp2);   // 2 / 27 * A2^3
  mpf_mul(mA2, mA1, mtmp1);     // A2 * A1
  mpf_div_int(mtmp1, 3, mtmp0); // A2 * A1 / 3
  mpf_sub(mtmp2, mtmp0, mtmp3); // 2 / 27 * A2^3 - A2 * A1 / 3
  mpf_add(mtmp3, mA0, me0);     // 2 / 27 * A2^3 - A2 * A1 / 3 + A0
//  e1s3 := e1 / 3;
  mpf_div_int(me1, 3, me1s3);
//  e0s2 := e0 / 2;
  mpf_div_int(me0, 2, me0s2);
//  e02s4 := e0s2 * e0s2;
  mpf_sqr(me0s2, me02s4);
//  e13s27 := e1s3 * e1s3 * e1s3;
  mpf_expt_int(me1s3, 3, me13s27);
//  e02s4pe13s27 := e02s4 + e13s27;                   // 判別値
  mpf_add(me02s4, me13s27, me02s4pe13s27);
// if e02s4pe13s27 < 1E-70 then e02s4pe13s27 := 0;    // 誤差許容値 1E-70 追加
//  cub0 := mpf_todouble(me02s4pe13s27);              // 値確認用
  mpf_set_dbl(mtmp0, MEM70);
  mpf_abs(me02s4pe13s27, mtmp1);
  if mpf_is_lt(mtmp1, mtmp0) then mpf_set0(me02s4pe13s27);
//  if e02s4pe13s27 >= 0 then begin                   // ru rv に負数が存在
  if s_mpf_is_ge0(me02s4pe13s27) then begin
    mpf_sqrt(me02s4pe13s27, mtmp0);
//    ru := -e0s2 + sqrt(e02s4pe13s27);
    mpf_sub(mtmp0, me0s2, mru);
//    rv := -e0s2 - sqrt(e02s4pe13s27);
    mpf_chs(me0s2, mtmp1);
    mpf_sub(mtmp1, mtmp0, mrv);
//    Qu := 0;
    mpf_set0(mQu);
  end
  else begin                          // ru rv に負数存在なし
    mpf_abs(me02s4pe13s27, mtmp0);
//    ru := sqrt(e02s4 + ABS(e02s4pe13s27));
    mpf_add(me02s4, mtmp0, mtmp1);
    mpf_sqrt(mtmp1, mru);
//    rv := ru;
    mpf_copy(mru, mrv);
//    Qu := arcCos(-e0s2 / ru);
    mpf_chs(me0s2, mtmp0);
    mpf_div(mtmp0, mru, mtmp1);
    mpf_arccos(mtmp1, mQu);
  end;

//  ruh1s3 := power(ru, 1/3);
  mpf_cbrt(mru, mruh1s3);
//  rvh1s3 := power(rv, 1/3);
  mpf_cbrt(mrv, mrvh1s3);

//  Qv := -Qu;
  mpf_chs(mQu, mQv);
//  Qus3 := Qu / 3;
  mpf_div_int(mQu, 3, mQus3);
//  Qvs3 := Qv / 3;
  mpf_div_int(mQv, 3, mQvs3);
// 実数部の計算
  mpf_set_pi(mpi);
//  u1 := ruh1s3 * cos(Qus3);
  mpf_cos(mQus3, mtmp0);
  mpf_mul(mruh1s3, mtmp0, mu1);
//  u2 := ruh1s3 * cos(Qus3 + 2 / 3 * pi);
  mpf_set_int(mtmp0, 2);
  mpf_div_int(mtmp0, 3, mtmp1);
  mpf_mul(mtmp1, mpi, mtmp0);
  mpf_add(mtmp0, mQus3, mtmp1);
  mpf_cos(mtmp1, mtmp0);
  mpf_mul(mruh1s3, mtmp0, mu2);
//  u3 := ruh1s3 * cos(Qus3 + 4 / 3 * pi);
  mpf_set_int(mtmp0, 4);
  mpf_div_int(mtmp0, 3, mtmp1);
  mpf_mul(mtmp1, mpi, mtmp0);
  mpf_add(mtmp0, mQus3, mtmp1);
  mpf_cos(mtmp1, mtmp0);
  mpf_mul(mruh1s3, mtmp0, mu3);
//  v1 := rvh1s3 * cos(Qvs3);
  mpf_cos(mQvs3, mtmp0);
  mpf_mul(mrvh1s3, mtmp0, mv1);
//  v2 := rvh1s3 * cos(Qvs3 + 2 / 3 * pi);
  mpf_set_int(mtmp0, 2);
  mpf_div_int(mtmp0, 3, mtmp1);
  mpf_mul(mtmp1, mpi, mtmp0);
  mpf_add(mtmp0, mQvs3, mtmp1);
  mpf_cos(mtmp1, mtmp0);
  mpf_mul(mrvh1s3, mtmp0, mv2);
//  v3 := rvh1s3 * cos(Qvs3 + 4 / 3 * pi);
  mpf_set_int(mtmp0, 4);
  mpf_div_int(mtmp0, 3, mtmp1);
  mpf_mul(mtmp1, mpi, mtmp0);
  mpf_add(mtmp0, mQvs3, mtmp1);
  mpf_cos(mtmp1, mtmp0);
  mpf_mul(mrvh1s3, mtmp0, mv3);

//  u1pv1 := u1 + v1;
  mpf_add(mu1, mv1, mu1pv1);
//  u2pv3 := u2 + v3;
  mpf_add(mu2, mv3, mu2pv3);
//  u3pv2 := u3 + v2;
  mpf_add(mu3, mv2, mu3pv2);
// A2 / 3
  mpf_div_int(mA2, 3, mtmp0);
//  cub2 := u1pv1 - A2 / 3;
  mpf_sub(mu1pv1, mtmp0, mcub2);
//  cub1 := u2pv3 - A2 / 3;
  mpf_sub(mu2pv3, mtmp0, mcub1);
//  cub0 := u3pv2 - A2 / 3;
  mpf_sub(mu3pv2, mtmp0, mcub0);

// 虚数部の計算
//  u1S := ruh1s3 * sin(Qus3);
  mpf_sin(mQus3, mtmp0);
  mpf_mul(mruh1s3, mtmp0, mu1S);
//  u2S := ruh1s3 * sin(Qus3 + 2 / 3 * pi);
  mpf_set_int(mtmp0, 2);
  mpf_div_int(mtmp0, 3, mtmp1);
  mpf_mul(mtmp1, mpi, mtmp0);
  mpf_add(mtmp0, mQus3, mtmp1);
  mpf_sin(mtmp1, mtmp0);
  mpf_mul(mruh1s3, mtmp0, mu2s);
//  u3s := ruh1s3 * sin(Qus3 + 4 / 3 * pi);
  mpf_set_int(mtmp0, 4);
  mpf_div_int(mtmp0, 3, mtmp1);
  mpf_mul(mtmp1, mpi, mtmp0);
  mpf_add(mtmp0, mQus3, mtmp1);
  mpf_sin(mtmp1, mtmp0);
  mpf_mul(mruh1s3, mtmp0, mu3s);
//  v1S := rvh1s3 * sin(Qvs3);
  mpf_sin(mQvs3, mtmp0);
  mpf_mul(mrvh1s3, mtmp0, mv1S);
//  v2S := rvh1s3 * sin(Qvs3 + 2 / 3 * pi);
  mpf_set_int(mtmp0, 2);
  mpf_div_int(mtmp0, 3, mtmp1);
  mpf_mul(mtmp1, mpi, mtmp0);
  mpf_add(mtmp0, mQvs3, mtmp1);
  mpf_sin(mtmp1, mtmp0);
  mpf_mul(mrvh1s3, mtmp0, mv2s);
//  v3S := rvh1s3 * sin(Qvs3 + 4 / 3 * pi);
  mpf_set_int(mtmp0, 4);
  mpf_div_int(mtmp0, 3, mtmp1);
  mpf_mul(mtmp1, mpi, mtmp0);
  mpf_add(mtmp0, mQvs3, mtmp1);
  mpf_sin(mtmp1, mtmp0);
  mpf_mul(mrvh1s3, mtmp0, mv3s);
//  u1pv1S := u1S + v1S;
  mpf_add(mu1s, mv1s, mu1pv1S);
//  u2pv3S := u2S + v3S;
  mpf_add(mu2s, mv3s, mu2pv3S);
//  u3pv2S := u3S + v2S;
  mpf_add(mu3s, mv2s, mu3pv2S);
//  if abs(u1pv1S) < MINIDE then u1pv1S := 0;   // 誤差許容値 MINIMAM 計算誤差対策 1E-24
  mpf_abs(mu1pv1S, mtmp0);
  if mpf_is_lt(mtmp0, mMINIDE) then mpf_set0(mu1pv1S);
//  if abs(u2pv3S) < MINIDE then u2pv3S := 0;   // 虚数部が指定値以下なら
  mpf_abs(mu2pv3S, mtmp0);
  if mpf_is_lt(mtmp0, mMINIDE) then mpf_set0(mu2pv3S);
//  if abs(u3pv2S) < MINIDE then u3pv2S := 0;   // 虚数部をゼロとみなします
  mpf_abs(mu3pv2S, mtmp0);
  if mpf_is_lt(mtmp0, mMINIDE) then mpf_set0(mu3pv2S);

  u1pv1S := mpf_todouble(mu1pv1S);
  u2pv3S := mpf_todouble(mu2pv3S);
  u3pv2S := mpf_todouble(mu3pv2S);

  if u1pv1S <> 0 then xim1 := floattostrF(u1pv1S, ffFixed, 10, 5) + ' i'
                 else begin
                  xim1 := '';
                  result := result or 1;
                 end;
  if u2pv3S <> 0 then xim2 := floattostrF(u2pv3S, ffFixed, 10, 5) + ' i'
                 else begin
                  xim2 := '';
                  result := result or 2;
                 end;
  if u3pv2S <> 0 then xim3 := floattostrF(u3pv2S, ffFixed, 10, 5) + ' i'
                 else begin
                  xim3 := '';
                  result := result or 4;
                 end;
  cub2 := mpf_todouble(mcub2);
  cub1 := mpf_todouble(mcub1);
  cub0 := mpf_todouble(mcub0);

  with Form1.Image1.Canvas do begin
    TextOut(20,  0,'λ1= ' + floattostrF(cub2, ffFixed, 15, 10) + ' ' + xim1);
    TextOut(20, 20,'λ2= ' + floattostrF(cub1, ffFixed, 15, 10) + ' ' + xim2);
    TextOut(20, 40,'λ3= ' + floattostrF(cub0, ffFixed, 15, 10) + ' ' + xim3);
  end;

POUT:
  mpf_clear3(mA2, mA1, mA0);
  mpf_clear4(me1, me0, me1s3, me0s2);
  mpf_clear3(me02s4, me13s27, me02s4pe13s27);
  mpf_clear4(mru, mrv, mruh1s3, mrvh1s3);
  mpf_clear4(mQu, mQv, mQus3, mQvs3);
  mpf_clear4(mu1, mu2, mu3, mv1);
  mpf_clear2(mv2, mv3);
  mpf_clear3(mu1pv1, mu2pv3, mu3pv2);
  mpf_clear4(mu1S, mu2S, mu3S, mv1S);
  mpf_clear2(mv2S, mv3S);
  mpf_clear3(mu1pv1S, mu2pv3S, mu3pv2S);
  mpf_clear3(mtmp0, mtmp1, mpi);
  mpf_clear(mMINIDE);
  mpf_clear2(mtmp2, mtmp3);
end;

//---------------------------------------
// 因数分解サブルーチン ルートの中の処理
//---------------------------------------
function TForm1.factorization2(ma, mh, mb, mg, mf, mc: mp_float; var mar, malfa: mp_float): boolean;
label
  POUT;
var
  ma0, mb0, mc0 : mp_float;
  mf0, mEM34, mEM56: mp_float;
  mtmp0, mtmp1, mtmp2: mp_float;
begin
  mpf_init3(ma0, mb0, mc0);
  mpf_init3(mf0, mEM34, mEM56);
  mpf_init3(mtmp0, mtmp1, mtmp2);

  result := true;
//  a0 := h * h - a * b;                          // a0の値がかなり小さくなるのでこの値が
  mpf_sqr(mh, mtmp0);
  mpf_mul(ma, mb, mtmp1);
  mpf_sub(mtmp0, mtmp1, ma0);
//  b0 := (g * h - a * f) * 2;                    // あまり小さくなると因数分解計算の誤差が大きくなります
  mpf_mul(mg, mh, mtmp0);
  mpf_mul(ma, mf, mtmp1);
  mpf_sub(mtmp0, mtmp1, mtmp2);
  mpf_mul_int(mtmp2, 2, mb0);
//  c0 := g * g - a * c;                          // 行列式の差分計算時のゼロ判定値によって最小値が変わります
  mpf_sqr(mg, mtmp0);
  mpf_mul(ma, mc, mtmp1);
  mpf_sub(mtmp0, mtmp1, mc0);
//  if abs(c0) < 1E-34 then c0 := 0;
  mpf_set_dbl(mEM34, 1E-34);
  mpf_abs(mc0, mtmp2);
  if mpf_is_lt(mtmp2, mEM34) then mpf_set0(mc0);
//  if abs(a0) < 1E-56 then a0 := 0;
  mpf_set_dbl(mEM56, 1E-56);
  mpf_abs(ma0, mtmp1);
  if mpf_is_lt(mtmp1, mEM56) then mpf_set0(ma0);
//  if a0 < 0 then
  mpf_abs(ma0, mtmp0);
  if s_mpf_is_neg(ma0) then
//    if abs(a0) < 1E-34 then a0 := 0;
    if mpf_is_lt(mtmp0, mEM34) then mpf_set0(ma0);
//  if (a0 < 0) or (c0 < 0) then begin            // a0 又は c0がマイナスの時は複素数となりルート不可
  if s_mpf_is_neg(ma0) or s_mpf_is_neg(mc0) then begin
    result := false;
    goto POUT;
  end;
//  f0 := b0 * b0 - 4 * a0 * c0;                  // ルートの中の二次方程式の中のルートの中の計算
  mpf_sqr(mb0, mtmp0);
  mpf_mul_int(ma0, 4, mtmp1);
  mpf_mul(mtmp1, mc0, mtmp1);
  mpf_sub(mtmp0, mtmp1, mf0);
  mpf_abs(mf0, mtmp2);
//  if abs(f0) < 1E-34 then f0 := 0;              // マイナスでも値が小さければ誤差としてゼロにします
  if mpf_is_lt(mtmp2, mEM34) then mpf_set0(mf0);
//  if (a0 >= 0) and (f0 = 0) then begin          // f0 がゼロならルートを開けます
  if s_mpf_is_ge0(ma0) and s_mpf_is0(mf0) then begin
//    ar := sqrt(a0);                             // a0 がゼロでも可能ですが βがゼロになることがあるで
    mpf_sqrt(ma0, mar);
//    alfa := sqrt(c0);                           // 因数分解値による連立方程式の為 a0(y^2)がゼロの時
    mpf_sqrt(mc0, malfa);
//    if b0 < 0 then alfa := -alfa;               // 因数分解NGとしています a0(y^2)がゼロに近くなると
    if s_mpf_is_neg(mb0) then mpf_chs(malfa, malfa);
  end                                             // 誤差も大きくなります。
  else                                            // βがゼロの時の方程式を作成すれば a0 がゼロでもOK
    result := false;

POUT:
  mpf_clear3(ma0, mb0, mc0);
  mpf_clear3(mf0, mEM34, mEM56);
  mpf_clear3(mtmp0, mtmp1, mtmp2);
end;

//-----------------------------------------------------------------------------------------------
// 因数分解
// a がゼロの時は因数分解できません。
// (α1x + β1y + γ1)(α2x + β2y + γ2)
//-----------------------------------------------------------------------------------------------
function TForm1.factorization(ma, mh, mb, mg, mf, mc: mp_float; var malf1, mbta1, mgam1, malf2, mbta2, mgam2: mp_float): boolean;
label
  POUT;
var
  mar, malfa          : mp_float;
  mtmp0, mtmp1, mtmp2 : mp_float;
  mtmp3, mtmp4, mtmp5 : mp_float;
//  tmp                 : double;
begin
  mpf_init2(mar, malfa);
  mpf_init3(mtmp0, mtmp1, mtmp2);
  mpf_init3(mtmp3, mtmp4, mtmp5);

  result := false;
  // detの計算 ゼロでないと因数分解できません
//  ar := a * b * c - a * f * f - b * g * g - c * h * h + 2 * f * g * h;
  mpf_mul(ma, mb, mtmp5);
  mpf_mul(mtmp5, mc, mtmp0);    // a * b * c
  mpf_mul(ma, mf, mtmp5);
  mpf_mul(mtmp5, mf, mtmp1);    // a * f * f
  mpf_mul(mb, mg, mtmp5);
  mpf_mul(mtmp5, mg, mtmp2);    // b * g * g
  mpf_mul(mc, mh, mtmp5);
  mpf_mul(mtmp5, mh, mtmp3);    // c * h * h
  mpf_mul_int(mf, 2, mtmp4);
  mpf_mul(mtmp4, mg, mtmp5);
  mpf_mul(mtmp5, mh, mtmp4);    // 2 * f * g * h

  mpf_sub(mtmp0, mtmp1, mtmp5);
  mpf_sub(mtmp5, mtmp2, mtmp0);
  mpf_sub(mtmp0, mtmp3, mtmp1);
  mpf_add(mtmp1, mtmp4, mar);
//  tmp := mpf_todouble(mar);
  // 因数分解出来なければ終了
//  if abs(ar) > 1E-24 then exit;                     // 1E-24 誤差許容値
  mpf_set_dbl(mtmp0, 1E-24);
  mpf_abs(mar, mtmp1);
  if mpf_is_gt(mtmp1, mtmp0) then goto POUT;
//  if abs(a) < 1E-50 then exit;                      // a がゼロの時は因数分解不可
  mpf_set_dbl(mtmp0, 1E-50);
  mpf_abs(ma, mtmp2);
  if mpf_is_lt(mtmp2, mtmp0) then goto POUT;
  result := factorization2(ma, mh, mb, mg, mf, mc, mar, malfa);
  if result then begin
//    alf1 := a;
    mpf_copy(ma, malf1);
//    bta1 := h - ar;
    mpf_sub(mh, mar, mbta1);
//    gam1 := g - alfa;
    mpf_sub(mg, malfa, mgam1);
//    alf2 := 1;
    mpf_set1(malf2);
//    bta2 := (h + ar) / a;
    mpf_add(mh, mar, mtmp0);
    mpf_div(mtmp0, ma, mbta2);
//    gam2 := (g + alfa) / a;
    mpf_add(mg, malfa, mtmp1);
    mpf_div(mtmp1, ma, mgam2);
  end;

POUT:
  mpf_clear2(mar, malfa);
  mpf_clear3(mtmp0, mtmp1, mtmp2);
  mpf_clear3(mtmp3, mtmp4, mtmp5);
end;

//----------------------------------------------------------------------------------------
// 連立方程式の解法 交点 X, Y を求めます
// 因数分解できた場合の処理
// 因数分解値一次式と楕円二元二次式の連立方程式の解法
function TForm1.quadratic(mA, mB, mC, mD, mE, mF, ma1, mb1, mg1: mp_float; var mx1, mx2: mp_float): byte;
label
  POUT;
var
  ma0, mb0, mc0, mf0  : mp_float;
  mm, mn          : mp_float;
  mtp0, mtp1, mtp2, mtp3 : mp_float;
  mtp4, mtp5 : mp_float;
begin
  mpf_init4(ma0, mb0, mc0, mf0);
  mpf_init2(mm, mn);
  mpf_init4(mtp0, mtp1, mtp2, mtp3);
  mpf_init2(mtp4, mtp5);

  result := 0;
//  if abs(b1) < 1e-40 then exit;        // b1の値がゼロだったら答え無し
  mpf_abs(mb1, mtp0);
  mpf_set_dbl(mtp1, 1E-40);
  if mpf_is_lt(mtp0, mtp1) then goto POUT;
//  m :=  -g1 / b1;                      // y = m + nx;
  mpf_div(mg1, mb1, mtp2);
  mpf_chs(mtp2, mm);
//  n := -a1 / b1;
  mpf_div(ma1, mb1, mtp2);
  mpf_chs(mtp2, mn);
//  a0 := A + C * n * n + B * n;
  mpf_mul(mC, mn, mtp3);      // C * n
  mpf_mul(mtp3, mn, mtp2);    // C * n * n
  mpf_mul(mB, mn, mtp3);      // B * n
  mpf_add(mA, mtp2, mtp1);    // A + C * n * n
  mpf_add(mtp1, mtp3, ma0);   // A + C * n * n + B * n
//  b0 := B * m + D + E * n + 2 * C * m * n;
  mpf_mul(mB, mm, mtp0);      // B * m
  mpf_mul(mE, mn, mtp1);      // E * n
  mpf_mul_int(mC, 2, mtp2);   // 2 * C
  mpf_mul(mtp2, mm, mtp3);    // 2 * C * m
  mpf_mul(mtp3, mn, mtp2);    // 2 * C * m * n
  mpf_add(mtp0, mD, mtp4);    // B * m + D
  mpf_add(mtp4, mtp1, mtp0);  // B * m + D + E * n
  mpf_add(mtp0, mtp2, mb0);   // B * m + D + E * n + 2 * C * m * n;
//  c0 := E * m + C * m * m + F;
  mpf_mul(mE, mm, mtp0);      // E * m
  mpf_mul(mC, mm, mtp1);      // C * m
  mpf_mul(mtp1, mm, mtp2);    // C * m * m
  mpf_add(mtp0, mtp2, mtp3);  // E * m + C * m * m
  mpf_add(mtp3, mF, mc0);     // E * m + C * m * m + F
//  f0 := b0 * b0 - 4 * a0 * c0;
  mpf_sqr(mb0, mtp0);         // b0 * b0
  mpf_mul_int(ma0, 4, mtp1);  // 4 * a0
  mpf_mul(mtp1, mc0, mtp2);   // 4 * a0 * c0
  mpf_sub(mtp0, mtp2, mf0);   // b0 * b0 - 4 * a0 * c0

//  if abs(f0) < 1E-20 then f0 := 0;     // 1E-20は誤差の許容値 誤差 ±1E-10
  mpf_abs(mf0, mtp0);
  mpf_set_dbl(mtp1, 1E-20);
  if mpf_is_lt(mtp0, mtp1) then mpf_set0(mf0);
//  if f0 = 0 then result := 1;
  if s_mpf_is0(mf0) then result := 1;
//  if f0 > 0 then result := 2;
  if s_mpf_is_gt0(mf0) then result := 2;
//  if (f0 < 0) or (abs(a0) < 1E-50) then begin        // f0 がマイナス a0がゼロなら答え無し
  mpf_set_dbl(mtp2, 1E-50);
  mpf_abs(ma0, mtp3);
  if s_mpf_is_neg(mf0) or mpf_is_lt(mtp3, mtp2) then begin
    result := 0;
    goto POUT;
  end;
//  x1 := (-b0 + sqrt(f0)) / a0 / 2;
  mpf_chs(mb0, mtp0);             // -b0
  mpf_sqrt(mf0, mtp1);            // sqrt(f0)
  mpf_add(mtp0, mtp1, mtp2);      // -b0 + sqrt(f0)
  mpf_div(mtp2, ma0, mtp3);       // (-b0 + sqrt(f0)) / a0
  mpf_div_int(mtp3, 2, mx1);      // (-b0 + sqrt(f0)) / a0 / 2
//  x2 := (-b0 - sqrt(f0)) / a0 / 2;
  mpf_sub(mtp0, mtp1, mtp2);      // -b0 - sqrt(f0)
  mpf_div(mtp2, ma0, mtp3);       // (-b0 - sqrt(f0)) / a0
  mpf_div_int(mtp3, 2, mx2);      // (-b0 - sqrt(f0)) / a0 / 2

  POUT:
  mpf_clear4(ma0, mb0, mc0, mf0);
  mpf_clear2(mm, mn);
  mpf_clear4(mtp0, mtp1, mtp2, mtp3);
  mpf_clear2(mtp4, mtp5);
end;

// 因数分解できなかった場合の処理４
// 2gx + 2fy + c := 0  の 一次式と楕円二元二次式の連立方程式の解法
function TForm1.quadratic4(mA1, mB1, mC1, mD1, mE1, mF1, mg, mf, mc: mp_float; var mx1, mx2: mp_float): boolean;
var
  mm, mn                  : mp_float;
  ma0, mb0, mc0, mf0      : mp_float;
  mtp0, mtp1, mtp2, mtp3  : mp_float;
begin
  mpf_init2(mm, mn);
  mpf_init4(ma0, mb0, mc0, mf0);
  mpf_init4(mtp0, mtp1, mtp2, mtp3);

  result := false;
//  m := - c / 2 / f;
  mpf_div_int(mc, 2, mtp0);
  mpf_div(mtp0, mf, mtp1);
  mpf_chs(mtp1, mm);
//  n := - g / f;
  mpf_div(mg, mf, mtp2);
  mpf_chs(mtp2, mn);
//  a0 := A1 + B1 * n + C1 * n * n;                 //  x^2
  mpf_mul(mB1, mn, mtp3);     // B1 * n
  mpf_mul(mc1, mn, mtp0);     // C1 * n
  mpf_mul(mtp0, mn, mtp1);    // C1 * n * n
  mpf_add(ma1, mtp3, mtp2);   // A1 + B1 * n
  mpf_add(mtp2, mtp1, ma0);
//  b0 := B1 * m + 2 * C1 * n * m + D1 + E1 * n;    //  x
  mpf_mul(mb1, mm, mtp0);     // B1 * m
  mpf_mul_int(mC1, 2, mtp1);  // 2 * C1
  mpf_mul(mn, mm, mtp3);      // n * m
  mpf_mul(mtp1, mtp3, mtp2);  // 2 * C1 * n * m
  mpf_mul(mE1, mn, mtp3);     // E1 * n
  mpf_add(mtp0, mtp2, mtp1);  // B1 * m + 2 * C1 * n * m
  mpf_add(mtp1, mD1, mtp2);   // B1 * m + 2 * C1 * n * m + D1
  mpf_add(mtp2, mtp3, mb0);   // B1 * m + 2 * C1 * n * m + D1 + E1 * n
//  c0 := C1 * m * m + E1 * m + F1;
  mpf_mul(mC1, mm, mtp0);     // C1 * m
  mpf_mul(mtp0, mm, mtp1);    // C1 * m * m
  mpf_mul(mE1, mm, mtp2);     // E1 * m
  mpf_add(mtp1, mtp2, mtp3);  // C1 * m * m + E1 * m
  mpf_add(mtp3, mF1, mc0);    // C1 * m * m + E1 * m + F1
//  f0 := b0 * b0 - 4 * a0 * c0;
  mpf_sqr(mb0, mtp0);         // b0 * b0
  mpf_mul_int(ma0, 4, mtp1);  // 4 * a0
  mpf_mul(mtp1, mc0, mtp2);   // 4 * a0 * c0
  mpf_sub(mtp0, mtp2, mf0);   // b0 * b0 - 4 * a0 * c0
//  if abs(f0) < 1E-10 then f0 := 0;     // 1E-10は誤差の許容値 誤差 ±0.00001
  mpf_set_dbl(mtp0, 1E-20);
  mpf_abs(mf0, mtp1);
  if mpf_is_lt(mtp1, mtp0) then mpf_set0(mf0);
//  if (f0 >= 0) and (a0 <> 0) then begin
  mpf_abs(ma0, mtp2);
  if s_mpf_is_ge0(mf0) and s_mpf_is_gt0(mtp2) then begin
//    x1 := (-b0 + sqrt(f0)) / 2 / a0;
    mpf_sqrt(mf0, mtp0);              // sqrt(f0)
    mpf_sub(mtp0, mb0, mtp1);         // -b0 + sqrt(f0)
    mpf_div_int(mtp1, 2, mtp2);       // (-b0 + sqrt(f0)) / 2
    mpf_div(mtp2, ma0, mX1);          // (-b0 + sqrt(f0)) / 2 / a0;
//    x2 := (-b0 - sqrt(f0)) / 2 / a0;
    mpf_chs(mb0, mtp2);                   // -b0
    mpf_sub(mtp2, mtp0, mtp1);         // -b0 - sqrt(f0
    mpf_div_int(mtp1, 2, mtp2);       // (-b0 - sqrt(f0)) / 2
    mpf_div(mtp2, ma0, mX2);          // (-b0 - sqrt(f0)) / 2 / a0
    result := true;
  end;

  mpf_clear2(mm, mn);
  mpf_clear4(ma0, mb0, mc0, mf0);
  mpf_clear4(mtp0, mtp1, mtp2, mtp3);
end;

//-------------------------------------------------------------
// 二つの楕円の交点計算
// 楕円１の角度が30°になるように座標変換をして計算します。
//-------------------------------------------------------------
procedure TForm1.cross_calc;
const
  K30 = 30;
  K180 = 180;
  K3   = 3;
var
  i, J, k                 : integer;
  mA1, mB1, mC1, mD1, mE1, mF1  : mp_float;
  mA2, mB2, mC2, mD2, mE2, mF2  : mp_float;
  ma,  mh,  mb,  mg,  mf,  mc   : mp_float;
  xflag                   : byte;
  oflag                   : byte;
  dflag                   : byte;
  iflag                   : boolean;
  marr1, marr2, marr3, marr4  : mTarray3x3;
  mah03, mah02, mah01, mah00  : mp_float;
  mlambda1, mlambda2, mlambda3  : mp_float;
  mdet                    : mp_float;
  mx1, mx2, mx3, mx4      : mp_float;
  my1, my2, my3, my4      : mp_float;
  x1, x2, x3, x4          : double;
  y1, y2, y3, y4          : double;
  xx                      : array[0..3] of double;
  yy                      : array[0..3] of double;
  xy                      : array[0..3] of byte;
  malf1, mgam1, mbta1, malf2, mgam2, mbta2: mp_float;

  mtp0, mtp1, mtp2, mtp3  : mp_float;

  ret                     : boolean;

  mstn, mdefQ             : mp_float;
  mqb, mqn                : mp_float;
  mnx, mny                : mp_float;
  mxob, myob              : mp_float;

  mq1b, mq2b              : mp_float;
  m30, m3                 : mp_float;

  mjm30                   : mp_float;

  q1b, q2b                : double;

  xxo                     : array[0..3] of Extended;
  yyo                     : array[0..3] of Extended;

  // 座標戻し 楕円の角度を元の角度に戻します
  procedure xyconvert(var mx, my : mp_float);
  var
    mstan, mqb, mqn: mp_float;
  begin
    mpf_init3(mstan, mqb, mqn);

//    stn := sqrt(x * x + y * y);
    mpf_sqr(mx, mtp0);            // x * x
    mpf_sqr(my, mtp1);            // y * y
    mpf_add(mtp0, mtp1, mtp2);    // x * x + y * y
    mpf_sqrt(mtp2, mstan);        // sqrt(x * x + y * y)
//    qb := arctan2(y, x);
    mpf_arctan2(my, mx, mqb);
//    qn - defQ
    mpf_sub(mqb, mdefQ, mqn);
//    x := cos(qn) * stn;
    mpf_cos(mqn, mtp3);
    mpf_mul(mtp3, mstan, mx);
//    y := sin(qn) * stn;
    mpf_sin(mqn, mtp3);
    mpf_mul(mtp3, mstan, my);

    mpf_clear3(mstan, mqb, mqn);
  end;

  // 交点丸表示
  procedure EllipseDraw(x, y: double);
  begin
    EllipseEx(image1.Canvas,
            image1.Height, 3, 1, clblack,
            5, 5,
            x * magnification - shift_x + draw_margin,
            y * magnification - shift_y + draw_margin,
            0, 0, 360);
  end;

  // 座標データー表示
  procedure TextoutXY(x, y: double; n, m: integer);
  begin
    x := (x + xshift) / scale;
    y := (y + yshift) / scale;
    image1.Canvas.TextOut( 20, 450 + n * 20, 'x' + intTostr(m) + '= ' + floatTostrF(x, ffFixed, 10, 4));
    image1.Canvas.TextOut(220, 450 + n * 20, 'y' + intTostr(m) + '= ' + floatTostrF(y, ffFixed, 10, 4));
  end;

  // 因数分解の必要なく方程式の解法可能な場合
  // 三次式解法が出来ても此処で計算しないと答えが出ない場合があります
  procedure HV_Move;
  var
    m1EM12, msa, msh, msb : mp_float;
  begin
    mpf_init4(m1EM12, msa, msh, msb);

    mpf_set_dbl(m1EM12, 1E-24);
    // 二つの楕円の縦横比が等しい場合
//    if (abs(a) < 1E-24) and (abs(h) < 1E-24) and (abs(b) < 1E-24) and (g <> 0) and (f <> 0) and (c <> 0) then begin
    mpf_abs(ma, msa);
    mpf_abs(mh, msh);
    mpf_abs(mb, msb);
    if mpf_is_lt(msa, m1EM12) and mpf_is_lt(msh, m1EM12) and mpf_is_lt(msb, m1EM12) and
                    not s_mpf_is0(mg) and not s_mpf_is0(mf) and not s_mpf_is0(mc) then begin
      // 2gx + 2fy + c := 0  の 一次式と楕円二元二次式の連立方程式の解法
      ret := quadratic4(mA1, mB1, mC1, mD1, mE1, mF1, mg, mf, mc, mx1, mx2);
      if ret then begin
//        y1 := - c / 2 / f - g / f * x1;
        mpf_chs(mc, mtp0);            // -c;
        mpf_div_int(mtp0, 2, mtp1);   // - c / 2
        mpf_div(mtp1, mf, mtp2);      // - c / 2 / f
        mpf_div(mg, mf, mtp3);        // g / f
        mpf_mul(mtp3, mx1, mtp1);     // g / f * x1;
        mpf_sub(mtp2, mtp1, my1);
//        y2 := - c / 2 / f - g / f * x2;
        mpf_mul(mtp3, mx2, mtp1);     // g / f * x1;
        mpf_sub(mtp2, mtp1, my2);
        dflag := 3;
      end;
    end;

    mpf_clear4(m1EM12, msa, msh, msb);
  end;

begin
  for i := 1 to 3 do
    for k := 1 to 3 do begin
      mpf_init4(marr1[i, k], marr2[i, k], marr3[i, k], marr4[i, k]);
    end;
  mpf_init2(mq1b, mq2b);
  mpf_init2(m30, m3);
  mpf_init2(mstn, mdefQ);
  mpf_init2(mqb, mqn);
  mpf_init2(mnx, mny);
  mpf_init2(mxob, myob);
  mpf_init3(mA1, mB1, mC1);
  mpf_init3(mD1, mE1, mF1);
  mpf_init3(mA2, mB2, mC2);
  mpf_init3(mD2, mE2, mF2);
  mpf_init4(mah03, mah02, mah01, mah00);
  mpf_init3(mlambda1, mlambda2, mlambda3);
  mpf_init3(ma, mh, mb);
  mpf_init3(mg, mf, mc);
  mpf_init(mdet);
  mpf_init4(mx1, mx2, mx3, mx4);
  mpf_init4(my1, my2, my3, my4);
  mpf_init(mjm30);
  mpf_init3(malf1, mgam1, mbta1);
  mpf_init3(malf2, mgam2, mbta2);
  mpf_init4(mtp0, mtp1, mtp2, mtp3);

// 座標変換角度 楕円比の大きいほうの軸角の計算角度を30°に設定します
// 座標原点は楕円1を0,0で変化しません
  // 楕円比計算
//  if ar1 >= br1 then q1b := ar1 / br1
//                else q1b := br1 / ar1;
//  if ar2 >= br2 then q2b := ar2 / br2
//                else q2b := br2 / ar2;
  if mpf_is_gt(mar1, mbr1) then mpf_div(mbr1, mar1, mq1b)
                           else mpf_div(mar1, mbr1, mq1b);
  if mpf_is_gt(mar2, mbr2) then mpf_div(mbr2, mar2, mq2b)
                           else mpf_div(mar2, mbr2, mq2b);

  // 楕円比フラグセット
  ZeroAngleF := False;
  if mpf_is_gt(mq2b, mq1b) then ZeroAngleF := true;
  // 楕円の角度処理
  // 座標変換角度設定
  mpf_set_int(m30, K30);
  if ZeroAngleF then
//    defQ := 30 - q2b
    mpf_sub(m30, mq2, mdefQ)
  else
//    defQ := 30 - q1b;
    mpf_sub(m30, mq1, mdefQ);
//  q1b := q1b + defQ;
  mpf_add(mq1, mdefQ, mq1b);
//  q2b := q2b + defQ;
  mpf_add(mq2, mdefQ, mq2b);
  angle180_amendment(mq1b);
  angle180_amendment(mq2b);
// nx := xo2 - xo1;
  mpf_sub(mxo2, mxo1, mnx);
// ny := yo2 - yo1 ;
  mpf_sub(myo2, myo1, mny);
  // 楕円同士の角度
//  qb := arctan2(ny, nx);
  mpf_arctan2(mny, mnx, mqb);
  // 計算上の楕円同士の角度
//  qn := qb + defQ / 180 * pi;
  mpf_set_pi(m3);
  mpf_div_int(mdefQ, K180, mtp1);
  mpf_mul(mtp1, m3, mdefQ);
  mpf_add(mqb, mdefQ, mqn);
  // 楕円の中心距離
//  stn := sqrt(nx * nx + ny * ny);
  mpf_sqr(mnx, mtp0);
  mpf_sqr(mny, mtp1);
  mpf_add(mtp0, mtp1, mtp0);
  mpf_sqrt(mtp0, mstn);
  // 計算上の楕円2の中心座標
//  xob := cos(qn) * stn;
//  yob := sin(qn) * stn;
  mpf_cos(mqn, m3);
  mpf_mul(m3, mstn, mxob);
  mpf_sin(mqn, m3);
  mpf_mul(m3, mstn, myob);

  // 計算上の楕円角度表示
  q1b := mpf_todouble(mq1b);
  q2b := mpf_todouble(mq2b);

  image1.Canvas.TextOut(590, 500, 'q1b ' + floatTostrF(q1b, ffFixed, 10, 2));
  image1.Canvas.TextOut(590, 520, 'q2b ' + floatTostrF(q2b, ffFixed, 10, 2));

// 楕円式の変換
  mpf_set0(mtp0);
  mpf_set0(mtp1);
  quadratic_transform(mar1, mbr1, mtp0, mtp1, mq1b, mA1, mB1, mC1, mD1, mE1, mF1);
  quadratic_transform(mar2, mbr2, mxob, myob, mq2b, mA2, mB2, mC2, mD2, mE2, mF2);

  determinant(mA1, mB1, mC1, mD1, mE1, mF1, marr1);         // 3x3 行列式に変換
  determinant(mA2, mB2, mC2, mD2, mE2, mF2, marr2);         // 3x3 行列式に変換
  //  　　　　3x3　   3x3   α^3   α^2    α     c
  difference1(marr1, marr2, mah03, mah02, mah01, mah00);    // α三次式に変換

  // 三次式の解法        α^3   α^2    α     c      λ1       λ2       λ3
  xflag := cubicequation(mah03, mah02, mah01, mah00, mlambda1, mlambda2, mlambda3);

  oflag := 0;
  dflag := 0;
//  a := 0;
  mpf_set0(ma);
//  h := 0;
  mpf_set0(mh);
//  b := 0;
  mpf_set0(mb);
//  g := 0;
  mpf_set0(mg);
//  f := 0;
  mpf_set0(mf);
//  c := 0;
  mpf_set0(mc);

//-----------------------------------------------------------------------------------------
  // 三次式の解法で、実数解 の 最初の一個が使用されます。
  // 実数解は一個　又は　三個
  if xflag and 1 = 1 then begin
    for i := 1 to 3 do
      for k := 1 to 3 do begin
//        arr3[i, k] := arr2[i, k] * lambda1;                // arr3 = arr2 * λ1
        mpf_mul(marr2[i, k], mlambda1, marr3[i, k])
      end;
    difference2(marr1, marr3, marr4);                        // arr4 = arr1 - arr3 λ1
    // 単に確認のみ 三次方程式の解の使用なので det は ゼロ
    difference3(marr4, ma, mh, mb, mg, mf, mc, mdet);        // det = arr4(det)
//    if abs(det) < 1E-20 then begin
    mpf_set_dbl(mjm30, 1E-20);
    s_mpf_abs(mdet);
//    x1 := mpf_todouble(mdet);
    if mpf_is_lt(mdet, mjm30) then begin
      // 因数分解
      if factorization(ma, mh, mb, mg, mf, mc, malf1, mbta1, mgam1, malf2, mbta2, mgam2) then begin
        oflag := 1;
      end;
      HV_Move;
    end;
  end;


  if dflag <> 0 then timer1.Interval := 50;

//-----------------------------------------------------------------------------------------
  iflag := false;
  // 因数分解ができた場合 因数分解が出来ても 答えが出ない場合もあります
  // 因数分解値の一次式同士の連立方程式を解いても答えは出せますが、組み合わせが
  // が発生するので、一次式と楕円の二元二次式の連立方程式を解きます
  if (oflag and 1 = 1) and (dflag < 15) then begin
    xflag := quadratic(mA1, mB1, mC1, mD1, mE1, mF1, malf1, mbta1, mgam1, mx1, mx2);
    if xflag <> 0 then begin
//      y1 := - gam1 / bta1 - alf1 / bta1 * x1;
      mpf_chs(mgam1, mtp0);         // - gam1
      mpf_div(mtp0, mbta1, mtp1);   // - gam1 / bta1
      mpf_div(malf1, mbta1, mtp2);  // alf1 / bta1
      mpf_mul(mtp2, mX1, mtp3);     // alf1 / bta1 * x1
      mpf_sub(mtp1, mtp3, my1);     // - gam1 / bta1 - alf1 / bta1 * x1
//      y2 := - gam1 / bta1 - alf1 / bta1 * x2;
      mpf_mul(mtp2, mX2, mtp3);     // alf1 / bta1 * x2;
      mpf_sub(mtp1, mtp3, my2);     // - gam1 / bta1 - alf1 / bta1 * x2
      dflag := 3;
      iflag := True;
    end;
    xflag := quadratic(mA1, mB1, mC1, mD1, mE1, mF1, malf2, mbta2, mgam2, mx3, mx4);
    if xflag <> 0 then begin
//      y3 := - gam2 / bta2 - alf2 / bta2 * x3;
      mpf_chs(mgam2, mtp0);         // - gam2
      mpf_div(mtp0, mbta2, mtp1);   // - gam2 / bta2
      mpf_div(malf2, mbta2, mtp2);  // alf2 / bta2
      mpf_mul(mtp2, mX3, mtp3);     // alf2 / bta2 * x3
      mpf_sub(mtp1, mtp3, my3);     // - gam2 / bta2 - alf2 / bta2 * x3
//      y4 := - gam2 / bta2 - alf2 / bta2 * x4;
      mpf_mul(mtp2, mX4, mtp3);     // alf2 / bta2 * x4;
      mpf_sub(mtp1, mtp3, my4);     // - gam2 / bta2 - alf2 / bta2 * x4
      dflag := dflag or 12;
      iflag := True;
    end;
  end;

  for i := 0 to 3 do begin
    xx[i] := 0;
    yy[i] := 0;
    xy[i] := 0;
  end;
  x1 := 0; x2 := 0; x3 := 0; x4 := 0;
  y1 := 0; y2 := 0; y3 := 0; y4 := 0;
  // 座標戻し 楕円の角度を元の角度に戻します
  if dflag and 1 = 1 then begin
    xyconvert(mx1, my1);
    x1 := mpf_todouble(mx1);
    y1 := mpf_todouble(my1);
    xx[0] := round(x1 * 10000) / 10000;
    yy[0] := round(y1 * 10000) / 10000;
  end;
  if dflag and 2 = 2 then begin
    xyconvert(mx2, my2);
    x2 := mpf_todouble(mx2);
    y2 := mpf_todouble(my2);
    xx[1] := round(x2 * 10000) / 10000;
    yy[1] := round(y2 * 10000) / 10000;
  end;
  if dflag and 4 = 4 then begin
    xyconvert(mx3, my3);
    x3 := mpf_todouble(mx3);
    y3 := mpf_todouble(my3);
    xx[2] := round(x3 * 10000) / 10000;
    yy[2] := round(y3 * 10000) / 10000;
  end;
  if dflag and 8 = 8 then begin
    xyconvert(mx4, my4);
    x4 := mpf_todouble(mx4);
    y4 := mpf_todouble(my4);
    xx[3] := round(x4 * 10000) / 10000;
    yy[3] := round(y4 * 10000) / 10000;
  end;

  // 接点二個のチェック 同一点座標の確認
  if (dflag = 15) then begin
    dflag := 0;
    for i := 0 to 3 do xy[i] := 0;
    for i := 0 to 3 do
      for k := i to 3 do
        if (k <> i) and (xx[i] = xx[k]) and (yy[i] = yy[k]) then inc(xy[k]);
    for i := 0 to 3 do if xy[i] = 0 then dflag := dflag + round(power(2, i));
  end;

  if dflag = 3 then
    if (xx[0] = xx[1]) and (yy[0] = yy[1]) then dflag := 1;
  if dflag = 12 then
    if (xx[2] = xx[3]) and (yy[2] = yy[3]) then dflag := 4;

  if iflag then image1.Canvas.TextOut(image1.Width - 20, 0, '因')
           else if dflag  <> 0 then image1.Canvas.TextOut(image1.Width - 20, 0, '〇');
  if (dflag = 1) or (dflag = 4) or (dflag = 13) or (dflag = 14) then timer1.Interval := 1000
    else
      if iflag or (dflag = 0) then timer1.Interval := 50;
  if dflag = 0 then timerF := false;
//-----------------------------------------------------------------------------------------

  i := -1;
  // 楕円弧上にある交点のみ表示
  if dflag and 1 = 1 then begin
    // 円弧上にあるかどうか判定 円弧上ならTrue
    if intersection_judge(Ellipse1, Ellipse2, x1, y1) then begin
      // 交点丸表示
      EllipseDraw(x1, y1);
      inc(i);
//      xx[i] := xx[0];
//      yy[i] := yy[0];
    end;
  end;
  if dflag and 2 = 2 then begin
    if intersection_judge(Ellipse1, Ellipse2, x2, y2) then begin
      EllipseDraw(x2, y2);
      inc(i);
      xx[i] := xx[1];
      yy[i] := yy[1];
    end;
  end;
  if dflag and 4 = 4 then begin
    if intersection_judge(Ellipse1, Ellipse2, x3, y3) then begin
      EllipseDraw(x3, y3);
      inc(i);
      xx[i] := xx[2];
      yy[i] := yy[2];
    end;
  end;
  if dflag and 8 = 8 then begin
    if intersection_judge(Ellipse1, Ellipse2, x4, y4) then begin
      EllipseDraw(x4, y4);
      inc(i);
      xx[i] := xx[3];
      yy[i] := yy[3];
    end;
  end;
  // 重複する交点検索   重複していたら xy[] > 0
  if dflag <> 0 then begin
    for j := 0 to i do xy[j] := 0;
    for j := 0 to i do begin
      for k := j to i do begin
        if j <> k then
          if (xx[j] = xx[k]) and (yy[j] = yy[k]) then begin
            inc(xy[K]);
          end;
        end;
      end;
    // 重複した交点の削除
    k := -1;
    for j := 0 to i do
      if xy[j] = 0 then begin
        inc(k);
        xxo[k] := xx[j];
        yyo[k] := yy[j];
      end;
    // 交点の座標表示
    i := 1;
    for j := 0 to k do begin
      TextoutXY(xxo[j], yyo[j], i, i);
      inc(i);
    end;
  end;

  for i := 1 to 3 do
    for k := 1 to 3 do begin
      mpf_clear4(marr1[i, k], marr2[i, k], marr3[i, k], marr4[i, k]);
    end;

  mpf_clear2(mq1b, mq2b);
  mpf_clear2(m30, m3);
  mpf_clear2(mstn, mdefQ);
  mpf_clear2(mqb, mqn);
  mpf_clear2(mnx, mny);
  mpf_clear2(mxob, myob);
  mpf_clear3(mA1, mB1, mC1);
  mpf_clear3(mD1, mE1, mF1);
  mpf_clear3(mA2, mB2, mC2);
  mpf_clear3(mD2, mE2, mF2);
  mpf_clear4(mah03, mah02, mah01, mah00);
  mpf_clear3(mlambda1, mlambda2, mlambda3);
  mpf_clear3(ma, mh, mb);
  mpf_clear3(mg, mf, mc);
  mpf_clear(mdet);
  mpf_clear4(mx1, mx2, mx3, mx4);
  mpf_clear4(my1, my2, my3, my4);
  mpf_clear(mjm30);
  mpf_clear3(malf1, mgam1, mbta1);
  mpf_clear3(malf2, mgam2, mbta2);
  mpf_clear4(mtp0, mtp1, mtp2, mtp3);
end;

// 角度の範囲０から360の範囲に調整
function TForm1.angle_amendment(angle : double): double;
begin
  repeat
    if angle >= 360  then angle := angle - 360;
    if angle < 0  then angle := angle + 360;
  until (angle < 360) and (angle >= 0);
  Result := angle;
end;

// 角度の範囲０から180の範囲に調整
procedure TForm1.angle180_amendment(var mangle : mp_float);
var
  mf180 : mp_float;
  s180 : pansiChar;
begin
  mpf_init(mf180);
  s180 := '180';
  mpf_read_decimal(mf180, s180);
  repeat
    if mpf_is_ge(mangle, mf180) then mpf_sub(mangle, mf180, mangle);
    if s_mpf_is_neg(mangle) then mpf_add(mangle, mf180, mangle);
  until mpf_is_lt(mangle, mf180) and s_mpf_is_ge0(mangle);
  mpf_clear(mf180);
end;

//------------------------------------------------
// 楕円弧上に交点があるかどうかの判定を行います
// Ellipse1 Ellipse2  楕円
// X  交点座標 X
// Y  交点座標 Y
//------------------------------------------------
function TForm1.intersection_judge(Ellipse1, Ellipse2: TEllipse; X, Y: double): boolean;
var
  qxy : double;
  endang : double;
begin
  Result := False;
  x := (x + xshift) / scale;
  y := (y + yshift) / scale;
  // 楕円弧１に対する交点の位置の角度計算
  qxy := arctan2((y - Ellipse1.fcy),(x - Ellipse1.fCx)) / pi * 180 - Ellipse1.fAngle;
  qxy := angle_amendment(qxy);
  endang := Ellipse1.endAngle;
  if Ellipse1.startAngle > Ellipse1.endAngle then begin
    endang := Ellipse1.endAngle + 360;
    if qxy < Ellipse1.startAngle then qxy := qxy + 360;
  end;
  // 楕円弧１の弧上に交点があるか判定
  if (qxy >= Ellipse1.startAngle) and (qxy <= endang) or
    (Ellipse1.startAngle = Ellipse1.endAngle) then else exit;

  // 楕円弧２に対する交点の位置の角度計算
  qxy := arctan2((y - Ellipse2.fcy),(x - Ellipse2.fCx)) / pi * 180 - Ellipse2.fAngle;
  qxy := angle_amendment(qxy);
  endang := Ellipse2.endAngle;
  if Ellipse2.startAngle > Ellipse2.endAngle then begin
    endang := Ellipse2.endAngle + 360;
    if qxy < Ellipse2.startAngle then qxy := qxy + 360;
  end;
  // 楕円弧２の弧上に交点があるか判定
  if (qxy >= Ellipse2.startAngle) and (qxy < endang) or
    (Ellipse2.startAngle = Ellipse2.endAngle) then Result := True
                                              else Result := False;
end;


var
  inpchF : boolean;
//--------------------------------------------------------
// 入力された楕円の描画
// 楕円作図のy方向は、楕円作図ルーチンで修正されます。
//--------------------------------------------------------
procedure TForm1.inputdata_drawing;
var
  left_min, left_max   :  double;
  top_min,  top_max    :  double;
  all_width, all_height:  double;
  ac1, ac2, acl        :  double;
  x1, x2, y1, y2       :  double;
  dx1, dy1, dq1        :  double;
  dx2, dy2, dq2        :  double;
begin
  inpchF := true;
// 表示設定用半径の大きい方の選択
  ac1 := Ellipse1.fRad_X;
  if Ellipse1.fRad_X < Ellipse1.fRad_Y then begin
     ac1 := Ellipse1.fRad_Y;
  end;
  ac2 := Ellipse2.fRad_X;
  if Ellipse2.fRad_X < Ellipse2.fRad_Y then begin
     ac2 := Ellipse2.fRad_Y;
  end;

// 計算スケール変換
  acl := ac1;
  if acl < ac2 then acl := ac2;
  scale := 200 / acl;
  mpf_set_dbl(mscale, scale);

  ac1 := ac1 * scale;
  ac2 := ac2 * scale;
  ar1 := Ellipse1.fRad_X * scale;
  br1 := Ellipse1.fRad_Y * scale;
  ar2 := Ellipse2.fRad_X * scale;
  br2 := Ellipse2.fRad_Y * scale;
  xo1 := Ellipse1.fCx * scale;
  xo2 := Ellipse2.fCx * scale;
  yo1 := Ellipse1.fcy * scale;
  yo2 := Ellipse2.fcy * scale;

  dq2 := Ellipse1.fAngle - Ellipse2.fAngle;
  repeat
    if dq2 >= 180 then dq2 := dq2 - 180;
    if dq2 < 0    then dq2 := dq2 + 180;
  until (dq2 < 180) and (dq2 >= 0);
  dq1 := 180 - dq2;
// 楕円の値の確認二つの楕円の値が近い場合計算しないフラグセット
  if (abs(dq2) < 1E-10) or (abs(dq1) < 1E-10) then begin
    if (abs(xo1 - xo2) < 1E-10) and
       (abs(yo1 - yo2) < 1E-10) and
       (abs(ar1 - ar2) < 1E-10) and
       (abs(br1 - br2) < 1E-10) then begin
          application.MessageBox('楕円の値が殆ど同じです','楕円の値',0);
          inpchF := false;
       end;
  end;
  if (abs(dq2 - 90) < 1E-10) then begin
    if (abs(xo1 - xo2) < 1E-10) and
       (abs(yo1 - yo2) < 1E-10) and
       (abs(ar1 - br2) < 1E-10) and
       (abs(br1 - ar2) < 1E-10) then begin
          application.MessageBox('楕円の値が殆ど同じです','楕円の値',0);
          inpchF := false;
       end;
  end;

// 座標変換 楕円1を原点へ移動
  xshift := xo1;
  xo2 := xo2 - xshift;
  xo1 := 0;

  yshift := yo1;
  yo2 := yo2 - yshift;
  yo1 := 0;

// 画像表示範囲設定
  left_min := xo1 - ac1;
  if xo2 - ac2 < left_min then left_min := xo2 - ac2;
  left_max := xo1 + ac1;
  if xo2 + ac2 > left_max then left_max := xo2 + ac2;
  all_width := left_max - left_min;     // 最大幅

  top_min := yo1 - ac1;
  if yo2 - ac2 < top_min then top_min := yo2 - ac2;
  top_max := yo1 + ac1;
  if yo2 + ac2 > top_max then top_max := yo2 + ac2;
  all_height := top_max - top_min;      // 最大高さ

  // 変倍率の設定
  top_max := (image1.Height - draw_margin * 2) / all_Height;
  magnification := (image1.Width - draw_margin * 2) / all_width;
  if magnification > top_max then magnification := top_max;
  // 移動量の設定
  shift_x := left_min * magnification;
  shift_y := top_min * magnification;

// イメージクリア
  imageClear;
  image1.Canvas.Brush.Style := bsClear;

// 楕円１作図
  x1 := xo1 * magnification - shift_x + draw_margin;
  y1 := yo1 * magnification - shift_y + draw_margin;
  x2 := xo2 * magnification - shift_x + draw_margin;
  y2 := yo2 * magnification - shift_y + draw_margin;
  EllipseEx(image1.Canvas,
            image1.Height,                                    // canvas高さ
            3,                                                // 線種
            1,                                                // 線幅
            clRed,                                            // 色
            ar1 * magnification,                              // 半径a
            br1 * magnification,                              // 半径b
            x1,                                               // 中心位置x
            y1,                                               // 中心位置y
            Ellipse1.fAngle,                                  // 回転角 deg
            Ellipse1.startAngle,                              // 作図開始角
            Ellipse1.endAngle);                               // 作図終了角
  EllipseEx(image1.Canvas,
            image1.Height, 0, 1, clRed, ar1 * magnification,
            br1 * magnification, x1, y1, Ellipse1.fAngle,
            Ellipse1.endAngle, Ellipse1.startAngle);
// 楕円２作図
  EllipseEx(image1.Canvas,
            image1.Height, 3, 1, clBlue, ar2 * magnification,
            br2 * magnification, x2, y2, Ellipse2.fAngle,
            Ellipse2.startAngle, Ellipse2.endAngle);
  EllipseEx(image1.Canvas,
            image1.Height, 0, 1, clBlue, ar2 * magnification,
            br2 * magnification, x2, y2, Ellipse2.fAngle,
            Ellipse2.endAngle, Ellipse2.startAngle);
// 中心線作図
  dq1 := Ellipse1.fAngle / 180 * pi;
  dx1 := cos(dq1) * 30;
  dy1 := sin(dq1) * 30;

  dq2 := (90 + Ellipse1.fAngle) / 180 * pi;
  dx2 := cos(dq2) * 30;
  dy2 := sin(dq2) * 30;

  StraightLineDraw(image1.Canvas, image1.Height, 1, 1,  clRed,
                                x1 - dx1, y1 - dy1, x1 + dx1, y1 + dy1, true);
  StraightLineDraw(image1.Canvas, image1.Height, 1, 1,  clRed,
                                x1 - dx2, y1 - dy2, x1 + dx2, y1 + dy2, true);

  dq1 := Ellipse2.fAngle / 180 * pi;
  dx1 := cos(dq1) * 30;
  dy1 := sin(dq1) * 30;

  dq2 := (90 + Ellipse2.fAngle) / 180 * pi;
  dx2 := cos(dq2) * 30;
  dy2 := sin(dq2) * 30;

  StraightLineDraw(image1.Canvas, image1.Height, 1, 1, clBlue,
                                x2 - dx1, y2 - dy1, x2 + dx1, y2 + dy1, true);
  StraightLineDraw(image1.Canvas, image1.Height, 1, 1, clBlue,
                                x2 - dx2, y2 - dy2, x2 + dx2, y2 + dy2, true);
end;

// 倍精度変換と計算呼び出し
// 多倍精度の計算なので計算用に改めてテキストから多倍精度に読み込みます
procedure TForm1.calcbegin;
const
  k360 = 360;
var
  m360      : mp_float;
  intext    : ansistring;
  minp      : mp_float;

  procedure Q360IN(var mq: mp_float);
  begin
    repeat
      if mpf_is_ge(mq, m360) then mpf_sub(mq, m360, mq);
      if s_mpf_is_neg(mq) then mpf_add(mq, m360, mq);
    until mpf_is_lt(mq, m360) and s_mpf_is_ge0(mq);
  end;

begin
  mpf_init2(mbr1, mbr2);
  mpf_init2(mar1, mar2);
  mpf_init2(mxo1, mxo2);
  mpf_init2(myo1, myo2);
  mpf_init2(mq1, mq2);

  mpf_init2(mst1, mst2);                 // 開始角   st
  mpf_init2(med1, med2);                 // 終了角   ed

  mpf_init(m360);
  mpf_init(minp);

// 計算用多倍長入力データーのセット
// 一度 double に変換して読み込むと桁落ちが発生するため直接読み込みます
  intext := ansistring(radius_a1_Edit.Text);
  mpf_read_decimal(minp, pansichar(intext));
  mpf_mul(minp, mscale, mar1);

  intext := ansistring(radius_b1_Edit.Text);
  mpf_read_decimal(minp, pansichar(intext));
  mpf_mul(minp, mscale, mbr1);

  intext := ansistring(radius_a2_Edit.Text);
  mpf_read_decimal(minp, pansichar(intext));
  mpf_mul(minp, mscale, mar2);

  intext := ansistring(radius_b2_Edit.Text);
  mpf_read_decimal(minp, pansichar(intext));
  mpf_mul(minp, mscale, mbr2);

  intext := ansistring(Center_x1_Edit.Text);
  mpf_read_decimal(minp, pansichar(intext));
  mpf_mul(minp, mscale, mxo1);

  intext := ansistring(Center_y1_Edit.Text);
  mpf_read_decimal(minp, pansichar(intext));
  mpf_mul(minp, mscale, myo1);

  intext := ansistring(Center_x2_Edit.Text);
  mpf_read_decimal(minp, pansichar(intext));
  mpf_mul(minp, mscale, mxo2);

  intext := ansistring(Center_y2_Edit.Text);
  mpf_read_decimal(minp, pansichar(intext));
  mpf_mul(minp, mscale, myo2);

  intext := ansistring(angle_q1_Edit.Text);
  mpf_read_decimal(mq1, pansichar(intext));

  intext := ansistring(angle_q2_Edit.Text);
  mpf_read_decimal(mq2, pansichar(intext));

  intext := ansistring(Start_angle_S1.Text);
  mpf_read_decimal(mst1, pansichar(intext));
  intext := ansistring(End_angle_E1.Text);
  mpf_read_decimal(med1, pansichar(intext));

  intext := ansistring(Start_angle_S2.Text);
  mpf_read_decimal(mst2, pansichar(intext));
  intext := ansistring(End_angle_E2.Text);
  mpf_read_decimal(med2, pansichar(intext));

// 楕円の角度は、一回転360°なので、360°以下にします
  mpf_set_int(m360, k360);
  Q360IN(mq1);
  Q360IN(mq2);
  Q360IN(mst1);
  Q360IN(med1);
  Q360IN(mst2);
  Q360IN(med2);

  cross_calc;           // 交点計算

// メモリーの解放
  mpf_clear2(mbr1, mbr2);
  mpf_clear2(mar1, mar2);
  mpf_clear2(mxo1, mxo2);
  mpf_clear2(myo1, myo2);
  mpf_clear2(mq1, mq2);

  mpf_clear2(mst1, mst2);
  mpf_clear2(med1, med2);

  mpf_clear(m360);
  mpf_clear(minp);
end;


var
  inpf : boolean;
// 計算データー入力処理 計算開始
procedure TForm1.SelectBtnClick(Sender: TObject);
var
  ch:       integer;
begin
  timer1.Enabled := False;
// 楕円１のデーター
  val(radius_a1_Edit.Text, Ellipse1.fRad_X, ch);
  if ch <> 0 then begin
    application.MessageBox('楕円１の半径a１数値ではありません', '楕円１の半径a１', 0);
    exit;
  end;
  if Ellipse1.fRad_X <= 0 then begin
    application.MessageBox('楕円１の半径a１が０又は０以下です', '楕円１の半径a１', 0);
    exit;
  end;
  val(radius_b1_Edit.Text, Ellipse1.fRad_Y, ch);
  if ch <> 0 then begin
    application.MessageBox('楕円１の半径b１数値ではありません', '楕円１の半径b１', 0);
    exit;
  end;
  if Ellipse1.fRad_Y <= 0 then begin
    application.MessageBox('楕円１の半径b１が０又は０以下です', '楕円１の半径b１', 0);
    exit;
  end;
  val(Center_x1_Edit.Text, Ellipse1.fCx, ch);
  if ch <> 0 then begin
    application.MessageBox('楕円１の中心位置x１数値ではありません', '楕円１の中心位置x１', 0);
    exit;
  end;
  val(Center_y1_Edit.Text, Ellipse1.fcy, ch);
  if ch <> 0 then begin
    application.MessageBox('楕円１の中心位置y１数値ではありません', '楕円１の中心位置y１', 0);
    exit;
  end;
  val(angle_q1_Edit.Text, Ellipse1.fAngle, ch);
  if ch <> 0 then begin
    application.MessageBox('楕円１の角度θ１数値ではありません', '楕円１の角度θ１', 0);
    exit;
  end;
  val(Start_angle_S1.Text, Ellipse1.startAngle, ch);
  if ch <> 0 then begin
    application.MessageBox('楕円１の開始角数値ではありません', '楕円１の開始角S1', 0);
    exit;
  end;
  val(End_angle_E1.Text, Ellipse1.endAngle, ch);
  if ch <> 0 then begin
    application.MessageBox('楕円１の終了角数値ではありません', '楕円１の終了角E1', 0);
    exit;
  end;

// 楕円２のデーター
  val(radius_a2_Edit.Text, Ellipse2.fRad_X, ch);
  if ch <> 0 then begin
    application.MessageBox('楕円２半径a２数値ではありません', '楕円２の半径a２', 0);
    exit;
  end;
  if Ellipse2.fRad_X <= 0 then begin
    application.MessageBox('楕円２の半径a２が０又は０以下です', '楕円２の半径a２', 0);
    exit;
  end;
  val(radius_b2_Edit.Text, Ellipse2.fRad_Y, ch);
  if ch <> 0 then begin
    application.MessageBox('楕円２の半径b２数値ではありません', '楕円２の半径b２', 0);
    exit;
  end;
  if Ellipse2.fRad_Y <= 0 then begin
    application.MessageBox('楕円２の半径b２が０又は０以下です', '楕円２の半径b２', 0);
    exit;
  end;
  val(Center_x2_Edit.Text, Ellipse2.fCx, ch);
  if ch <> 0 then begin
    application.MessageBox('楕円２の中心位置x２数値ではありません', '楕円２の中心位置x２', 0);
    exit;
  end;
  val(Center_y2_Edit.Text, Ellipse2.fcy, ch);
  if ch <> 0 then begin
    application.MessageBox('楕円２の中心位置y２数値ではありません', '楕円２の中心位置y２', 0);
    exit;
  end;
  val(angle_q2_Edit.Text, Ellipse2.fAngle, ch);
  if ch <> 0 then begin
    application.MessageBox('楕円２の角度θ２数値ではありません', '楕円２の角度θ２', 0);
    exit;
  end;
  val(Start_angle_S2.Text, Ellipse2.startAngle, ch);
  if ch <> 0 then begin
    application.MessageBox('楕円２の開始角数値ではありません', '楕円２の開始角S2', 0);
    exit;
  end;
  val(End_angle_E2.Text, Ellipse2.endAngle, ch);
  if ch <> 0 then begin
    application.MessageBox('楕円２の終了角数値ではありません', '楕円２の終了角E2', 0);
    exit;
  end;

  mpF_init(mscale);

// 入力された楕円角度の値修正 0 ～ 360　の範囲に入る様にします。
  Ellipse1.fAngle := angle_amendment(Ellipse1.fAngle);
  Ellipse2.fAngle := angle_amendment(Ellipse2.fAngle);
  Ellipse1.startAngle := angle_amendment(Ellipse1.startAngle);
  Ellipse1.endAngle := angle_amendment(Ellipse1.endAngle);
  Ellipse2.startAngle := angle_amendment(Ellipse2.startAngle);
  Ellipse2.endAngle := angle_amendment(Ellipse2.endAngle);
  inputdata_drawing;    // 入力画像表示
  if inpchF then        // 入力値に問題が無かったら交点計算
    calcbegin;
  if inpF then timer1.Enabled := true;
  mpF_clear(mscale);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if timer1.Enabled then begin
    timer1.Enabled := false;
    inpF := False;
    timerf := false;
  end
  else begin
    timer1.Enabled := True;
    timerf := true;
    inpF := true;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 if timerf then begin
   Ellipse1.fAngle := Ellipse1.fAngle + 0.125;
   Ellipse2.fAngle := Ellipse2.fAngle + 0.25;
   angle_q2_Edit.Text := floatTostr(Ellipse2.fAngle);
   angle_q1_Edit.Text := floatTostr(Ellipse1.fAngle);
   SelectBtnClick(nil);
 end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  clientHeight := 560;
  clientWidth  := 1000;
  top := (screen.Height- height) div 2;
  left := (screen.Width - width) div 2;
// 線種配列确保
  setlength(LPitch, LineN);
// 線種データーセット
  LPitch[0].segment := 2;         // 破線
  LPitch[0].Pitch[0] := 6;
  LPitch[0].Pitch[1] := 3;

  LPitch[1].segment := 4;         // １点鎖線
  LPitch[1].Pitch[0] := 15;
  LPitch[1].Pitch[1] := 3;
  LPitch[1].Pitch[2] := 3;
  LPitch[1].Pitch[3] := 3;

  LPitch[2].segment := 6;         //　２点鎖線
  LPitch[2].Pitch[0] := 18;
  LPitch[2].Pitch[1] := 3;
  LPitch[2].Pitch[2] := 3;
  LPitch[2].Pitch[3] := 3;
  LPitch[2].Pitch[4] := 3;
  LPitch[2].Pitch[5] := 3;
// イメージクリア
  imageClear;
  image1.Canvas.Font.Name := 'ＭＳ ゴシック';
//  image1.Canvas.Font.Style := [fsbold];
  image1.Canvas.Font.Height := 14;
end;

end.
